function conte_chat_locutorio()
{
	var self;
	var view;
	var texto;
	this.table;
	this.n_lineas=0;
	var o_locutorio;
	this.liberar=function()
	{
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_chat', null);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_mensaje_server', null);
		
		o_locutorio=null;
		if(texto) texto.blur();
		liberar_recur(view);
		texto=null;
		this.table=null;		
		view=null;
	};
	this.init=function(p_olocu,p_top,p_bottom)
	{		 
		self=this;
		o_locutorio=p_olocu;
		var tbl_data = [];
		var i; 
		view= Titanium.UI.createView(
			{
				left: 0,
				top: p_top,
				bottom: p_bottom,
				right:0,
				backgroundColor:"#ffffff"
			}
		);
		texto = Titanium.UI.createTextField({  
    		left:0,  
    		top:0,  
    		right:factor(40),  
			height:factor(40),
    		color:'#000000',
    		enableReturnKey: true,
    		maxLength:255,  
    		hintText:L("escribe_aqui",'Escribe aquí'),  
    		font:{fontSize:factor(16),fontWeight:'normal',fontFamily:'Helvetica Neue'},
			borderStyle:Titanium.UI.INPUT_BORDERSTYLE_ROUNDED,  
    		keyboardType:Titanium.UI.KEYBOARD_DEFAULT,  
    		returnKeyType:Titanium.UI.RETURNKEY_DEFAULT  
		});  
		texto.addEventListener('return', function(e)
		{
			if (trim(texto.value)=="")	return;
			enviar_chat(trim(texto.value));			
			texto.value="";
			texto.blur();
		});	
		texto.addEventListener('focus', function f(e)
		{
			texto.blur();
			texto.removeEventListener('focus',f);
		});		
		view.add(texto);  
		var b_say=Titanium.UI.createImageView({						 
    		top:0,  
    		right:0,
    		width:factor(40),  
    		height:factor(40),
		 image:"/enter.png"
		});
		view.add(b_say);  
		b_say.addEventListener('click', function(e)
		{
			if (trim(texto.value)=="")
			{
				texto.blur();
				return;
			}
						sonido("boton.wav");

			enviar_chat(trim(texto.value));
			texto.value="";
			texto.blur();
		}); 

		this.table=Titanium.UI.createScrollView({
			contentWidth:'auto',
			contentHeight:'auto',				layout: 'vertical',

			//opacity:.0,
			top:factor(44),
			bottom:0,
			//borderRadius:10,
			backgroundColor:"#ffffff",
			showVerticalScrollIndicator:true
			});	


		view.add(this.table);

		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_chat', ev_locutorio_chat);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_mensaje_server', ev_mensaje_server);

		return view;
		//----------------------------------------------------------------------------------------------------
	};
	function ev_mensaje_server(p_param)
	{
		if(!view && self) return;
		var t_texto=p_param[0].texto;
		self.crea_row(t_texto,true);
	}	
	
	function enviar_chat(p_texto)
	{
		oglobal.ologic.notificar_chat_locutorio(o_locutorio.id,p_texto);
	}
	this.crea_row=function(p_texto,p_server)
	{
			var label;
		if (this.n_lineas>=oglobal.k_max_rows_chat_salon)
		{
			//borramos
			objshow(this.table,false);
			if(this.table.children)
			{
	 			var children = this.table.children.slice(0);
	 			var t_tot=this.table.children.length;
	    		for (var i = 0; i < t_tot; ++i) {
	 	               if(children[i]) this.table.remove(children[i]);
	        	}
	       }
	       	objshow(this.table,true);
	       this.n_lineas=0;

		}
			//var row = Ti.UI.createTableViewRow({height:'auto'});
			if(p_server)
			{
			     label = Ti.UI.createLabel(
			    {
			    	top: 0,
			        left: 0,		        
			        font:{fontSize:factor(14),fontFamily:'Helvetica Neue'},
			        color: '#000000',
			        text: p_texto   		        
			    });
				
			}
			else
			{
			     label = Ti.UI.createLabel(
			    {
			    	top: 0,
			        left: 0,		        
			        font:{fontSize:factor(16),fontWeight:'bold',fontFamily:'Helvetica Neue'},
			        color: '#000000',
			        text: p_texto   		        
			    });				
			}
	        //row.add(label);
			//return row;
		var t_top,t_row,t_g;

		this.table.add(label);
		t_top=0;
		if(this.table.children)
		{
			t_top=0;		
			for(t_g=0;t_g<this.table.children.length;t_g++)
			{
				t_row=this.table.children[t_g];
				if(t_row) t_top=t_top+t_row.size.height;
			}
		}
		if (os_ios())
		{
			var t_off=t_top+1-this.table.size.height;
			if(t_off>0) this.table.setContentOffset({x:0 ,y:t_off});			
		}
		else
		{
			this.table.scrollTo(0,t_top);
		}
		this.n_lineas++;
		};	
	function add_chat(p_nick,p_texto,p_sonar)
	{
		self.crea_row(trim(p_nick)+": "+p_texto,false);
		if(p_sonar) sonido("snd_chat.wav");
	}
	function ev_locutorio_chat(p_param)
	{
		var t_olocu=p_param[0].olocu;
		if(t_olocu.id!=o_locutorio.id) return;
		var t_clave=p_param[0].clave;
		var t_texto=p_param[0].texto;
		if(!t_olocu.hash_usuarios.hasItem(t_clave)) return;
		var t_om=t_olocu.hash_usuarios.items[t_clave];
		add_chat(t_om.nick,t_texto,true);	
	}
	this.cerrar_teclado = function()
	{
		texto.blur();
	};
}
module.exports =conte_chat_locutorio;