function obj_logica(p_ip,p_port)
{
	var self=this;
	this.readBuffer = Ti.createBuffer({length:1024*7});
	var procesando;
	this.eventos=[];	
	this.connectingSocket = null;
	this.desconexion_controlada=false;
	
	this.host=p_ip;
	this.puerto=p_port;
	this.sock_conectado=false;
	this.sock_error_num=10;
	this.sock_error_descrip='';
	
	this.trozo_men_previo='';
	this.getmyaddEventListener=function(p_event)
	{
		return self.eventos[p_event];
	};
	this.myaddEventListener =function(p_this,p_event,p_fun){
		self.eventos[p_event]=p_fun;	
	};
	this.myremoveEventListener =function(p_this,p_event,p_fun){
		self.eventos[p_event]=null;	
	};

	this.disparar_evento = function (p_this,p_evento,param)
	{
		//Titanium.API.info('disparo '+p_evento);
		if (self.eventos[p_evento]!=null)		self.eventos[p_evento](param);
	};
	   this.sock_conectar=function(p_this)
    {   
    procesando=false;
    self=this;
    self.trozo_men_previo="";
    if (self.connectingSocket == null) {
        self.desconexion_controlada=false;
        // no hay conexion
        //Titanium.API.info('solicito conexion');
        try {
            self.connectingSocket = Ti.Network.Socket.createTCP({
                host:self.host,
                port:self.puerto,
                connected:function(e) {
                    self.sock_conectado=true;
                    self.sock_error_num=0;
                    self.sock_error_descrip="";
                    self.connectingSocket=e.socket;
                    Ti.Stream.read(self.connectingSocket,self.readBuffer,readCallback);

                    //Titanium.API.info('lanzo evento conectado');
                    self.disparar_evento(self,"conectado",0);
                    

                },
                error:function(e) {
                    self.sock_conectado=false;
                    self.sock_error_num=e.errorCode;
                    self.sock_error_descrip=e.error;
                    self.connectingSocket=null;
                    
                    //if(!self.desconexion_controlada) self.disparar_evento(self,"desconectado",0);
                    Titanium.API.info('error crear socket'+e.error);
                
                },
                closed:function(e) {
                    self.sock_conectado=false;
                    self.connectingSocket=null;
                    Titanium.API.info('************************************************socket cerrado');
                    if(!self.desconexion_controlada) self.disparar_evento(self,"desconectado",0);                                       
                }
            });
            //Titanium.API.info('conecto socket');
            self.connectingSocket.connect();
            return true;
        }
        catch (e) {
            self.sock_conectado=false;
            self.sock_error_num=-1;
            self.sock_error_descrip=e.toString();
            self.connectingSocket=null;
            Titanium.API.info('********* error ')+e.toString;

        }
    }
    else {
        // se llama a conectar y ya está conectado
        Titanium.API.info('conexion con socket ya conectado');
        self.disparar_evento(self,"conectado",0);
        return true;
    }
    return false;   
    };

	
	function readCallback(e) {
			if(typeof(e)!="undefined")
			{
				if (e.bytesProcessed == -1) return;
				var str = Ti.Codec.decodeString({source:self.readBuffer, length:e.bytesProcessed, charset: Ti.Codec.CHARSET_ISO_LATIN_1});
			}
			else
			{
				self.sock_desconectar(self,false);
				return;
			}
			self.readBuffer.clear(); // clear the buffer before the next read			
			// queue up the next read
			self.trozo_men_previo=validar_mensaje(self.trozo_men_previo+str);
			str=null;
			if(self.connectingSocket)
			{
				Ti.Stream.read(self.connectingSocket,self.readBuffer,readCallback);				
			}
						
		}

	this.sock_desconectar=function(p_this,p_controlado)
    {
        //self.trozo_men_previo="";
        if(!p_controlado)
        {            
            self.connectingSocket=null;
            self.sock_conectado=false;
        }
        else
        {
            self.desconectar();
        }
        
        return;
        // no cerramos porque en ios9 cierra la app parece ser que al hacer close del socket si le pilla de malas
        
        self.desconexion_controlada=p_controlado;
        self.sock_error_num=0;
        self.sock_error_descrip="";
        if (self.connectingSocket != null) {
            try {
                self.connectingSocket.close();
                self.connectingSocket = null;
            }
            catch (e) {
                self.sock_error_num=-1;
                self.sock_error_descrip=e.toString();
            }
        }
        else {
            // no está conectado        
        }
        self.trozo_men_previo="";
        self.sock_conectado=false;
        self.connectingSocket = null;
        
    };
	
	

	format_mensaje=function(p_mensa)
	{
		var t_mensa,t_buf;
		var t_len;
		t_mensa=p_mensa
		t_len=t_mensa.length;
		t_buf=String.fromCharCode(1)+padr(t_len,6,' ')+t_mensa+String.fromCharCode(1)
		return t_buf;
	}
	this.estoy_conectado=function(p_this)
	{
		if(!Titanium.Network.online) return false;
		if (self.connectingSocket == null) return false;
		var estado=self.connectingSocket.state;
		if (estado==Ti.Network.Socket.CONNECTED) return true;
		return false;
		/*Ti.Network.Socket.INITIALIZED:
		Ti.Network.Socket.CONNECTED:
		Ti.Network.Socket.LISTENING:
		Ti.Network.Socket.CLOSED:
		Ti.Network.Socket.ERROR:*/					
	}
	this.sock_enviar=function(p_mensa)
	{
		var t_buf;
		
		t_buf=format_mensaje(p_mensa);
	
		if (self.connectingSocket == null)
		{
			return false;
		}
		try {
			var buf = Ti.createBuffer({ length: 1024 });
			var l=Ti.Codec.encodeString({source:t_buf, sourceLength:t_buf.length,dest:buf, charset: Ti.Codec.CHARSET_ISO_LATIN_1});
			//self.connectingSocket.write(Ti.createBuffer({value:t_str }));
			self.connectingSocket.write(buf);
			//Ti.Stream.pump(self.connectingSocket,pumpCallback,2024, true);

			//Ti.Stream.read(self.connectingSocket,BUFFER,pumpCallback);
			//Ti.Codec.decodeString			
			return true;
		}
		
		catch (e) {
			self.sock_error_num=-1;
			self.sock_error_descrip=e.toString();
			return false;
		}
	
	}
	pumpCallback=function(e) 
	{
		if (e.bytesProcessed == -1) { // EOF
			// statusArea.value = "<EOF> - Can't perform any more operations on connected socket";
		}
		
		else if (e.errorDescription == null || e.errorDescription == "" || e.bytesProcessed>0) {
			var string = Ti.Codec.decodeString({source: e.buffer, length: e.bytesProcessed, charset: Ti.Codec.CHARSET_ISO_LATIN_1})
			self.trozo_men_previo=validar_mensaje(self.trozo_men_previo+string);
			//self.trozo_men_previo=validar_mensaje(self.trozo_men_previo+e.buffer.toString());
			//validar_mensaje(Ti.Codec.decodeString({source: e.buffer, length: e.bytesProcessed, charset: Ti.Codec.CHARSET_ISO_LATIN_1}}));
		}
		else {
			
			//self.trozo_men_previo=""
		}
	};
	this.set_puertos=function (p_server,p_port)
	{
		self.host=p_server;
		self.puerto=p_port;
	};
	
	function validar_mensaje(p_mensa)
	{
		var t_ret='',t_trozo='';
		var t_len=0;
		var t_mensa,t_paquete,t_resto;
		if (procesando)
		{
			return p_mensa;
		}
		//Titanium.API.info('buffer recibido '+p_mensa);
		t_mensa=p_mensa;
		if (1==t_mensa.charCodeAt(0))
		{
			t_trozo=t_mensa.substr(1,6);
			t_len=myval(t_trozo);
			if (1==t_mensa.charCodeAt(1+6+t_len))	// tenemos un paquete
			{
				t_paquete=t_mensa.substr(7,t_len);							
				//Titanium.API.info('completo '+t_paquete);
				procesando=true
				analiza_mensaje(t_paquete)
				procesando=false					
				// miramos si en el paquete viene más de un mensaje
				t_resto=t_mensa.substring(1+6+t_len+1)
				if (t_resto!="")
				{					
					return validar_mensaje(t_resto);
				}				
				return "";
			}
			else{
				// el paquete está cortado inacabado
				//Titanium.API.info('incompleto');
				return t_mensa;
			}
		}	
		else
		{
			Titanium.API.info('ALERTAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA');
			return "";
		}	
		
	}
	// analisis de mensajes recibidos del servidor
	function analiza_mensaje(p_mensa)
	{
		var t_tipo,t_mensa;
		t_tipo=myval(p_mensa.substr(0,3));
		t_mensa=p_mensa.substring(3);
		//Titanium.API.info('mensaje recibido '+p_mensa.substr(0,3)+t_mensa);
		switch(t_tipo)
		{
			case k_men_superbola:
				procesar_superbola(t_mensa);
				break;
			case k_men_sonido_file:
				procesar_sonido_file(t_mensa);
				break;
			case k_men_candidatos:
				procesar_candidatos(t_mensa);
				break;
			case k_men_notificar_numeros_salidos:
				procesar_notificar_numeros_salidos(t_mensa);
				break;
			case k_men_ganador_linea:
				procesar_ganador(1,t_mensa);
				break;
			case k_men_ganador_linea2:
				procesar_ganador(2,t_mensa);
				break;
			case k_men_ganador_bingo:
				procesar_ganador(3,t_mensa);
				break;
			case k_men_ganador_bote:
				procesar_ganador(4,t_mensa);
				break;
			case k_men_bingo_fin:
				procesar_fin_bingo(t_mensa);
				break;
			case k_men_marcar_numero:
				procesar_marcar_numero(t_mensa);
				break;
			case k_men_bola_sacada:
				procesar_bola_sacada(t_mensa);
				break;
			case k_men_bingo_iniciado_general:
				procesar_bingo_iniciado_general(t_mensa);
				break;
			case k_men_bingo_iniciado_participante:
				procesar_bingo_iniciado_participante(t_mensa);
				break;
			case k_men_login: // respuesta a login
				procesar_login(t_mensa);
				break;
			case k_men_enumerar_salones: // responde con la lista de salones
				procesar_enumerar_salones(t_mensa);
				break;
			case k_men_enumerar_salones3: // responde con la lista de salones
				procesar_enumerar_salones_con_nivel(t_mensa);
				break;
			case k_men_identificar: // responde aceptando o no la entrada a salon
				procesar_identificar(t_mensa);
				break;
			case k_men_enumerar_mesas: // responde enumerando las mesas del salon
				procesar_enumerar_mesas(t_mensa);
				break;
			case k_men_estado_silla: // responde enumerando las mesas del salon
				procesar_estado_silla(t_mensa);
				break;
			case k_status: // 
				procesar_status(t_mensa);
				break;
			case k_men_tiempo_inicio_siguiente_bingo:
				procesar_tiempo_inicio_siguiente_bingo(t_mensa);
				break;
				
			case k_men_notificar_cartones_posibles:
				procesar_notificar_cartones_posibles(t_mensa);
				break;
			case k_men_notificar_cartones_elegidos:
				procesar_notificar_cartones_elegidos(t_mensa);
				break;
			case k_men_carton_seleccionado:
				procesar_carton_seleccionado(t_mensa);
				break;	
			case k_men_enum_jugadores_reducido2: // responde con la lista de jugadores
				procesar_enumerar_jugadores(t_mensa);
				break;
			case k_men_conexion: // responde con la lista de jugadores
				procesar_inicio_jugador_conectado(t_mensa);
				break;
			case k_men_desconexion:
				procesar_jugador_desconectado(t_mensa);
				break;
			case k_men_chat:
				procesar_chat_recibido(t_mensa);
				break;
			case k_men_mensaje_server:
				procesar_mensaje_server_recibido(t_mensa);
				break;
			case k_men_config:
				procesar_configuracion_jugador(t_mensa);
				break;
			case k_men_notificar_cambio_estado:
					procesar_notificar_cambio_estado_jugador(t_mensa);
				break;
			case k_men_reconectado:
				procesar_reconectado(t_mensa);
				break;
			case k_men_enum_almacen:
				procesar_enum_almacen(t_mensa);
				break;
			case k_men_enum_tienda:
				procesar_enum_tienda(t_mensa);
				break;
			case k_men_mensaje_server_personalizado:
				procesar_mensaje_server_personalizado(t_mensa);
				break;
			case k_men_open_web:
				procesar_open_web(t_mensa);
				break;
			case k_men_invitar_a_jugar:
				procesar_invitar_a_jugar(t_mensa);
				break;			
			case k_men_enum_amigos:
				procesar_enum_amigos(t_mensa);
				break;
			case k_men_locutorio_crear:
				procesar_locutorio_crear(t_mensa);
				break;			
			case k_men_locutorio_enumerar_presentes:
				procesar_locutorio_enumerar_presentes(t_mensa);
				break;			
			case k_men_locutorio_chat:
				procesar_locutorio_chat(t_mensa);
				break;			
			case k_men_locutorio_entrada:
				procesar_locutorio_entrada(t_mensa);
				break;			
			case k_men_locutorio_entrar_invitado:
				procesar_locutorio_entrar_invitado(t_mensa);
				break;			
			case k_men_locutorio_salida:
				procesar_locutorio_salida(t_mensa);
				break;			
			case k_men_locutorio_mensaje_server:
				procesar_locutorio_mensaje_server_recibido(t_mensa);
				break;
			case k_men_locutorio_invitado:
				procesar_locutorio_invitado(t_mensa);
				break;			
			case k_men_locutorio_expulsar:
				procesar_locutorio_expulsado(t_mensa);
				break;			
			case k_men_locutorio_walki:
				procesar_locutorio_walki(t_mensa);
				break;
			case k_men_reproducir_tts:
				procesar_reproducir_tts(t_mensa);
				break;			
			default:
		        Titanium.API.info('------------------------------------------------------ mensaje no reconocido'+t_tipo);
		        break;

		}
	}

	function procesar_login(p_mensa)
	{
		// procesa respuesta a login
		var t_error, t_estadis, t_noconex, t_welcome;
        var t_clave;
        var t_pos, t_len_welcome;
        oglobal.licenciado=true;
		//Titanium.API.info('identificado');
        t_pos = 0;
        t_clave = myval(p_mensa.substr(t_pos, 30));
        t_pos += 30;
        t_estadis = trim(p_mensa.substr(t_pos, 40));
        t_pos += 40
        t_noconex = trim(p_mensa.substr(t_pos, 40));
        t_pos += 40
        t_len_welcome = myval(p_mensa.substr(t_pos, 4));
        t_pos += 4
        t_welcome = trim(p_mensa.substr(t_pos, t_len_welcome));
        t_pos += t_len_welcome;
        t_error = trim(p_mensa.substring(t_pos));
        var param=[
        {clave:t_clave,invitado:false,	error:t_error}];
        self.disparar_evento(self,"login",param);

	}	
	
	function procesar_enumerar_salones_con_nivel(p_mensa)
	{
        var t_id;
        var t_nombre;
        var t_mesas;
        var t_jugadores;
        var t_pos;
        var t_max;
        var t_coste;
        var t_n;

        
        var t_osalon;
        t_pos = 0;
        t_n=0;
        oglobal.hash_salones= new hash;
        
        while(true)
        {
            t_id = myval(p_mensa.substr(t_pos, 30));
            t_pos += 30;
            t_nombre = trim(p_mensa.substr(t_pos, 40));
            t_pos += 40;
            t_mesas = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            t_jugadores = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            t_max = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            t_coste = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            var t_nivel = myval(p_mensa.substr(t_pos, 2));
            t_pos += 2;
            t_n=t_n+1;
            t_osalon= new class_salon_enum();
            t_osalon.clave=t_id;            
            t_osalon.nombre=t_nombre;
            t_osalon.n_mesas=t_mesas;
            t_osalon.n_jugadores=t_jugadores;
            t_osalon.n_max_jugadores=t_max;
            t_osalon.coste=t_coste;
            t_osalon.nivel=t_nivel;
            oglobal.hash_salones.setItem(t_osalon.clave,t_osalon);
            if (t_pos >= p_mensa.length)
            {
            	break;	
            }            
        }        
        self.disparar_evento(self,"enumerar_salones",0);

	}	
	function procesar_enumerar_salones(p_mensa)
	{
        var t_id;
        var t_nombre;
        var t_mesas;
        var t_jugadores;
        var t_pos;
        var t_max;
        var t_coste;
        var t_n;

        
        var t_osalon;
        t_pos = 0;
        t_n=0;
        oglobal.hash_salones= new hash;
        
        while(true)
        {
            t_id = myval(p_mensa.substr(t_pos, 30));
            t_pos += 30;
            t_nombre = trim(p_mensa.substr(t_pos, 40));
            t_pos += 40;
            t_mesas = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            t_jugadores = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            t_max = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            t_coste = myval(p_mensa.substr(t_pos, 6));
            t_pos += 6;
            t_n=t_n+1;
            t_osalon= new class_salon_enum();
            t_osalon.clave=t_id;            
            t_osalon.nombre=t_nombre;
            t_osalon.n_mesas=t_mesas;
            t_osalon.n_jugadores=t_jugadores;
            t_osalon.n_max_jugadores=t_max;
            t_osalon.coste=t_coste;
            t_osalon.nivel=2;
            oglobal.hash_salones.setItem(t_osalon.clave,t_osalon);
            if (t_pos >= p_mensa.length)
            {
            	break;	
            }            
        }        
        self.disparar_evento(self,"enumerar_salones",0);

	}	
	function procesar_identificar(p_mensa)
	{
		// procesa respuesta a identificacion , puede ser ok o no
		// si es ok me mandará de seguido las mesas
		var t_error, t_ok;
		//Titanium.API.info('identificado en salon');
        t_pos = 0;
        t_ok = myval(p_mensa.substr(t_pos, 1));
        t_pos += 1;
        t_error = trim(p_mensa.substr(t_pos));
        var param=[
        {ok:t_ok,	error:t_error}];        
        self.disparar_evento(self,"identificado",param);
	}	
	function procesar_enumerar_mesas(p_mensa)
	{
        var t_mensa;
        var t_pos;
        var t_n;
        var t_n_mesa,t_n_mesas, t_situ_mesa;
        var t_n_mesas_reportadas;
        var t_cortar_envidar;
        var t_omesa,t_actualizando;
        t_mensa = p_mensa;
        t_pos = 0;
        t_n_mesas = myval(t_mensa.substr(t_pos, 3));
        
        t_pos += 3;
        t_n_mesas_reportadas = myval(p_mensa.substr(t_pos, 3));
        t_pos += 3;
        t_actualizando=false;
        if (t_n_mesas_reportadas!=t_n_mesas)
        {
        	// mandan configuración de una mesa
        	 t_actualizando=true;
        	 if(!oglobal.hash_mesas) return;
        } 
        else
        {
        	oglobal.hash_mesas= new hash;	
        	//t_n_mesas_reportadas=4////////////////////////////QUITAR
        }
                
        
       	for(var ii=1; ii<=t_n_mesas_reportadas; ii++)
		{	
			t_n_mesa = myval(p_mensa.substr(t_pos, 3));
            t_pos += 3;
			if(t_actualizando)
			{
				t_omesa=oglobal.hash_mesas.items[t_n_mesa];
				if(!t_omesa) return;
			}
			else
			{
				t_omesa = new class_mesa();
				inicializar_mesa(t_omesa);	
			}
            
            
            t_situ_mesa = myval(p_mensa.substr(t_pos, 1));
            t_pos += 1;

            t_omesa.n_mesa = t_n_mesa;
            t_omesa.situacion = t_situ_mesa;
            if(t_actualizando)
            {
            	oglobal.hash_mesas.setItem(t_n_mesa,t_omesa);
            	self.disparar_evento(self,"mesa_actualizada",t_n_mesa);
            	return;
            }
            
            
            oglobal.hash_mesas.setItem(ii,t_omesa);
		}
		self.disparar_evento(self,"enumerar_mesas",0);
	}//aqui
	function procesar_enumerar_jugadores(p_mensa)
	{
        var t_mensa;
        var t_pos,t_clave;
        var t_n,i;
        var t_n_juga;
        var t_oj;
        t_mensa = p_mensa;
        t_pos = 0;
        t_n_juga = myval(t_mensa.substr(t_pos, 3));        
        t_pos += 3;
       	for(var i=1; i<=t_n_juga; i++)
		{	
			t_clave=myval(p_mensa.substr(t_pos, 10));
			if(oglobal.hash_jugadores.hasItem(t_clave)==true)
			{
				t_oj = oglobal.hash_jugadores.items[t_clave];
			}
			else
			{
	            t_oj = new class_jugador();
				inicializar_jugador(t_oj);            				
			}
                        
            t_oj.clave = t_clave; 
            t_pos+=10;
			t_oj.nick=trim(p_mensa.substr(t_pos, 30)); 
			t_pos+=30;
			t_oj.mesa=myval(p_mensa.substr(t_pos, 3)); 
			t_pos+=3;
			t_oj.silla=myval(p_mensa.substr(t_pos, 1)); 
			t_pos+=1;
			t_oj.cara=myval(p_mensa.substr(t_pos, 6)); 
			t_pos+=6;
			t_oj.color=myval(p_mensa.substr(t_pos, 20)); 
			t_pos+=20;
			t_oj.estado=myval(p_mensa.substr(t_pos, 1)); 
			t_pos+=1;
			t_oj.moderador=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
			t_pos+=1;
			t_oj.invisible=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
			t_pos+=1;
			t_oj.licenciado=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
			t_pos+=1;
			t_oj.principiante=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
			t_pos+=1;
			t_oj.avatar_propio=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
			t_pos+=1;
			t_oj.tiene_trofeos=myval(p_mensa.substr(t_pos, 1)); 
			t_pos+=1;
			t_oj.nivel_torneos=myval(p_mensa.substr(t_pos, 1)); 
			t_pos+=1;
			t_oj.nivel_riqueza=myval(p_mensa.substr(t_pos, 1)); 
			t_pos+=1;
			t_oj.lng=trim(p_mensa.substr(t_pos, 2));
			t_pos+=2
			t_oj.id_facebook=trim(p_mensa.substr(t_pos, 20));
			t_pos+=20;

									
			oglobal.hash_jugadores.setItem(t_oj.clave,t_oj);
			
		}		
		self.disparar_evento(self,"enumerar_jugadores",0);
	}
	function procesar_inicio_jugador_conectado(p_mensa)
	{
        var t_pos;
        var t_oj;

      


        //Titanium.API.info('inicio de conexion');
        t_oj = new class_jugador();
		inicializar_jugador(t_oj);        
        t_pos = 0;            
        t_oj.clave = myval(p_mensa.substr(t_pos, 30)); 
        t_pos+=30;
        if(oglobal.hash_jugadores.hasItem(t_oj.clave)==true) 
        {
        	return;
        }
        
        t_oj.robot=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false);
        t_pos+=1;
		t_oj.nick=trim(p_mensa.substr(t_pos, 30)); 
		t_pos+=30;
		t_oj.mesa=myval(p_mensa.substr(t_pos, 3)); 
		t_pos+=3;
		t_oj.silla=myval(p_mensa.substr(t_pos, 3)); 
		t_pos+=3;
		t_oj.cara=myval(p_mensa.substr(t_pos, 6)); 
		t_pos+=6;
		t_oj.color=myval(p_mensa.substr(t_pos, 30)); 
		t_pos+=30;
		t_oj.estado=myval(p_mensa.substr(t_pos, 3)); 
		t_pos+=3;
		t_oj.tiene_trofeos=myval(p_mensa.substr(t_pos, 1)); 
		t_pos+=1;
		t_oj.nivel_torneos=myval(p_mensa.substr(t_pos, 1)); 
		t_pos+=1;
		t_oj.nivel_riqueza=myval(p_mensa.substr(t_pos, 1)); 
		t_pos+=1;
		
		oglobal.hash_jugadores.setItem(t_oj.clave,t_oj);
		//Titanium.API.info('fin de conexion');
		// inmediatamente despues viene el mesaje de datos especiales que se recibe en procesar_fin_jugador_conexion'
	}
	function procesar_fin_jugador_conectado(p_mensa)
	{
        var t_pos;
        var t_oj,t_clave;
		//Titanium.API.info('inicio de conexion2');
        t_pos = 0;            
        t_clave= myval(p_mensa.substr(t_pos, 30)); 
        t_pos+=30;
		if(oglobal.hash_jugadores.hasItem(t_clave)==false) return;
		t_oj = oglobal.hash_jugadores.items[t_clave];        
		t_oj.moderador=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
		t_pos+=1;
		t_oj.invisible=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
		t_pos+=1;
		t_oj.licenciado=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
		t_pos+=1;
		t_oj.principiante=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
		t_pos+=1;
		t_oj.avatar_propio=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false); 
		t_pos+=1;
		t_oj.lng=trim(p_mensa.substr(t_pos, 2));
		t_pos+=2
		t_oj.id_facebook=trim(p_mensa.substr(t_pos, 20));
		t_pos+=20;

		oglobal.hash_jugadores.setItem(t_oj.clave,t_oj);
		//Titanium.API.info('fin de conexion2');
		self.disparar_evento(self,"jugador_conectado",t_clave);
		//Titanium.API.info('fin de conexion2a');
	}
	function procesar_jugador_desconectado(p_mensa)
	{
        var t_pos,t_oj;
        var t_clave;
        var t_controlada;
		//Titanium.API.info('desconexión jugador recibida');
        t_pos = 0;            
        t_clave= myval(p_mensa.substr(t_pos, 30)); 
        t_pos+=30;
        if(t_clave==oglobal.clave_usuario) return;
        t_controlada=iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false);
		if(oglobal.hash_jugadores.hasItem(t_clave)==false) return;
		self.disparar_evento(self,"jugador_desconectado",t_clave);
		t_oj = oglobal.hash_jugadores.items[t_clave,t_controlada];
		oglobal.hash_jugadores.removeItem(t_clave);
				
	}
	function procesar_estado_silla(p_mensa)
		{
			// colocar o levantar jugador			
	        var t_clave,t_mesa,t_silla,t_estado;
	        var t_oj;
	        var t_pos;
   	        if(oglobal.hash_jugadores==null) return;

	        t_pos = 0;
	        t_clave = myval(p_mensa.substr(t_pos, 30));
	        t_oj=oglobal.hash_jugadores.items[t_clave];	// obtengo el objeto del jugador
	        if (t_oj==null) return;
	        t_pos += 30;
	        t_mesa = myval(p_mensa.substr(t_pos, 3));
	        t_pos += 3;
	        t_silla = myval(p_mensa.substr(t_pos, 3));
	        t_pos += 3;
	        t_estado = myval(p_mensa.substr(t_pos, 1));
	        t_pos += 1;
	        t_miron = iif(myval(p_mensa.substr(t_pos, 1))==0,false,true);
	        t_pos += 1;
	        
			//Titanium.API.info('colocar jugador '+t_clave.toString()+t_oj.nick+'  en mesa '+t_mesa.toString()+' silla '+t_silla.toString());

	        var param=[
	        {oj:t_oj,	mesa:t_mesa, silla:t_silla, estado:t_estado,miron:t_miron}];
	        self.disparar_evento(self,"estado_silla",param);
	        if(t_estado==1)
	        {
	      		oglobal.hash_jugadores.items[t_clave].mesa = t_mesa;
				oglobal.hash_jugadores.items[t_clave].silla = t_silla;	        	
	        }
	        else
	        {
	      		oglobal.hash_jugadores.items[t_clave].mesa = 0;
				oglobal.hash_jugadores.items[t_clave].silla = 0;	        	
	        }	
		}	
		function procesar_chat_recibido(p_mensa)
		{
						
	        var t_clave,t_texto;
	        var t_oj;
	        var t_pos;
	        t_pos = 0;
	        if(oglobal.hash_jugadores==null) return;
	        t_clave = myval(p_mensa.substr(t_pos, 30));
	        if(oglobal.hash_jugadores.hasItem(t_clave)==false) return;
	        t_oj=oglobal.hash_jugadores.items[t_clave];	// obtengo el objeto del jugador
	        t_pos+=30;
	        t_texto=trim(p_mensa.substring(t_pos));
	        
			//Titanium.API.info("chat recibido de "+t_oj.nick+":"+t_texto);

	        var param=[
	        {oj:t_oj,	texto:t_texto}];
	        self.disparar_evento(self,"chat_salon_recibido",param);
	
		}			
		function procesar_mensaje_server_recibido(p_mensa)
		{
						
	        var t_latente,t_texto;

	        t_pos = 0;
	        t_latente = iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false);
	        t_pos++;
	        t_texto=trim(p_mensa.substring(t_pos));
	        
	        var param=[
	        {texto:t_texto}];
	        self.disparar_evento(self,"mensaje_server",param);
	
		}
		function procesar_notificar_cambio_estado_jugador(p_mensa)
		{
			var t_pos,t_clave,t_estado
			var t_oj
			t_pos=0
			t_clave = myval(p_mensa.substr(t_pos, 30));
			t_pos+=30;
			t_estado = myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;

	        if(oglobal.hash_jugadores.hasItem(t_clave)==false) return;
	        t_oj=oglobal.hash_jugadores.items[t_clave];	// obtengo el objeto del jugador
			t_oj.estado=t_estado;
			oglobal.hash_jugadores.setItem(t_oj.clave,t_oj);			
	        var param=[
	        {oj:t_oj,estado:t_estado}];			
	        self.disparar_evento(self,"cambio_estado_jugador",param);
		}
		function procesar_reconectado(p_mensa)
		{
			var t_pos=0;			
			var t_clave = myval(p_mensa.substr(t_pos, 30));
			t_pos+=30;
			Titanium.API.info("-----------RECONECTAR ");
	        var param=[
	        	{clave:t_clave}];//			
			self.disparar_evento(self,"reconectado",param);
		}

// solicitudes al servidor********************************************************************************
	this.notificar_login =function(p_this,p_nick,p_pass,p_id_face)
	{
		var t_mensa,t_version='?';
		
		t_version=get_version()
		
		t_mensa=fid(k_men_login);
		t_mensa=t_mensa+'A'+padr(t_version,20,' ');
		t_mensa=t_mensa+padr(p_nick,20,' ');
		t_mensa=t_mensa+padr(p_pass,20,' ');
		t_mensa=t_mensa+padr(oglobal.serial,30,' ');
		t_mensa=t_mensa+get_lng_dispositivo();
		t_mensa=t_mensa+"@"+padr(p_id_face,30,' ');		
		try {
			t_mensa=t_mensa+Ti.Platform.osname+"|"+Ti.Platform.ostype+"|"+Ti.Platform.version+"|"+Ti.Platform.model+"|"+Ti.Platform.runtime+"|"+Ti.Platform.processorCount.toString();			
		}
		catch (e) {
		}

		self.sock_enviar(t_mensa);
	};
	this.solicitar_enumerar_salones =function(p_clave)
	{
		var t_mensa = fid(k_men_enumerar_salones3);
        t_mensa += padr(p_clave.toString(),30,' ');
        self.sock_enviar(t_mensa);
	}
	this.identificar =function()
	{
		var t_mensa = fid(k_men_identificar);
		t_mensa += padr(oglobal.salon.toString(),30,' ');
        t_mensa += padr(oglobal.clave_usuario.toString(),30,' ');
        t_mensa += padr(oglobal.nick.toString(),30,' ');
        t_mensa += padr(oglobal.serial,30,' ');
        t_mensa+=get_version()
        t_mensa+=get_lng_dispositivo()
        t_mensa+=padr(oglobal.id_profile_facebook,20," ");
        self.sock_enviar(t_mensa);
	}
	this.solicitar_sentarse=function(p_mesa,p_silla,p_estado)
	{
		var t_mensa = fid(k_men_estado_silla);
		t_mensa += padr(p_mesa.toString(),3,' ');
        t_mensa += padr(p_silla.toString(),3,' ');
        t_mensa += p_estado.toString();
        self.sock_enviar(t_mensa);		
	}
	this.solicitar_enumerar_jugadores =function(p_salon)
	{
		var t_mensa = fid(k_men_enum_jugadores_reducido2);
        t_mensa += p_salon.toString();
        //Titanium.API.info('solicito jugadores');        
        self.sock_enviar(t_mensa);
	}
	this.enviar_chat =function(p_txt)
	{
		var t_mensa = fid(k_men_chat)+p_txt;
        self.sock_enviar(t_mensa);
	}
	

	
	
	//**************************************************************************************************
	this.get_jugador_mesa_silla = function(p_mesa,p_silla)
	{
		var t_j
		for (var i in oglobal.hash_jugadores.items) {
			t_j=oglobal.hash_jugadores.items[i];
			if(t_j.mesa==p_mesa && t_j.silla==p_silla  && t_j.estado!=k_estado_jug_mirando  ) return t_j 			
		}
		return null;
	}

	this.desconectar=function()
	{
		var t_mensa = fid(k_men_desconexion);
        self.sock_enviar(t_mensa);

	}
	this.notificar_enum_almacen = function(p_clave)
	{
		var t_mensa;
		t_mensa = fid(k_men_enum_almacen)
		t_mensa = t_mensa+ padr(p_clave.toString(),30," ");		
		t_mensa = t_mensa+ "6"
		self.sock_enviar(t_mensa);		
	}
	this.notificar_enum_tienda = function(p_clave)
	{
		var t_mensa;
		t_mensa = fid(k_men_enum_tienda)
		t_mensa = t_mensa+ padr(p_clave.toString(),30," ");		
		t_mensa = t_mensa+ "6"
		self.sock_enviar(t_mensa);		
	}
	
	this.notificar_configuracion_jugador = function(p_cara)
	{
		var t_mensa,t_clave;
		t_clave=oglobal.clave_usuario;
		var t_oj = oglobal.hash_jugadores.items[t_clave];		
		t_mensa = fid(k_men_config)
		t_mensa = t_mensa+ padr(p_cara.toString(),6," ");
		t_mensa = t_mensa+ padr(t_oj.color.toString(),30," ");
		self.sock_enviar(t_mensa);		
	};
	this.compra_articulos =function(p_clave,p_hash)
	{
		var t_mensa = fid(k_men_compra_articulos);
		var t_oelem,t_n_elem;
		var t_mensa2;
        t_n_elem=0;
        t_mensa2="";
        for (var t_n in p_hash.items)
		{						
			t_oelem=p_hash.getItem(t_n);
			for(var t_g=1;t_g<=t_oelem.alcanti;t_g++)
			{
				t_n_elem++;		
        		t_mensa2 += padr(t_oelem.arclave.toString(),30," ");
        		t_mensa2 += padr("1",4," ");
        	}        	
       }
        t_mensa += padr(p_clave.toString(),30," ");
        t_mensa+="6";
        t_mensa += padr(t_n_elem.toString(),4," ");
        t_mensa+=t_mensa2;
       self.sock_enviar(t_mensa);
	};
	this.empenar_articulos =function(p_clave,p_hash)
	{
		var t_mensa = fid(k_men_empenar_articulos);
		var t_oelem,t_n_elem;
		var t_mensa2;
        t_n_elem=0;
        t_mensa2=""

		
		var t_array=p_hash.items.slice();
		t_array.sort(orden_fecha);
        
        for (var t_n in t_array)
		{						
			t_oelem=t_array[t_n];
			for(var t_g=1;t_g<=t_oelem.alcanti;t_g++)
			{
				t_n_elem++;		
        		t_mensa2 += padr(t_oelem.arclave.toString(),30," ");
        		t_mensa2 += padr("1",4," ");
        		t_mensa2 += padr(t_oelem.arprecio.toString(),8," ");
        	}        	
       }
        t_mensa += padr(p_clave.toString(),30," ");
        t_mensa+="6";
        t_mensa += padr(t_n_elem.toString(),4," ");
        t_mensa+=t_mensa2;
       self.sock_enviar(t_mensa);
        	
	};
	this.notificar_prohibir_mirar_cartas =function(p_prohibir)
	{
		
		var t_mensa = fid(k_men_notificar_probibir_mirar_cartas);
        t_mensa += iif(p_prohibir,"1","0");
        self.sock_enviar(t_mensa);
	};
	this.invitar_a_jugar =function(p_clave)
	{		
		var t_mensa = fid(k_men_invitar_a_jugar);
        t_mensa += padr(p_clave.toString(),30," ");
        self.sock_enviar(t_mensa);
	};
	this.notificar_resultado_invitacion=function(p_clave_invitador, p_resultado)
	{		
		var t_mensa = fid(k_men_resultado_invitacion);
        t_mensa += padr(p_clave_invitador.toString(),30," ");
        t_mensa += padr(oglobal.clave_usuario.toString(),30," ");
        t_mensa += padr(oglobal.salon.toString(),30," ");
        t_mensa += padr(p_resultado.toString(),6," ");
        self.sock_enviar(t_mensa);
	};
	this.add_remove_amigos =function(p_clave)
	{		
		var t_mensa = fid(k_men_add_remove_amigos);
        t_mensa += padr(oglobal.clave_usuario.toString(),10," ");
        t_mensa += padr(p_clave.toString(),10," ");
        self.sock_enviar(t_mensa);
	};
	this.enum_amigos =function()
	{		
		var t_mensa = fid(k_men_enum_amigos);
        t_mensa += padr(oglobal.clave_usuario.toString(),10," ");
        self.sock_enviar(t_mensa);
	};
	this.notificar_walki =function(p_partida)
	{
		
		var t_mensa = fid(k_men_partida_notificar_walki);
        t_mensa += padr(p_partida.toString(),30," ");
        self.sock_enviar(t_mensa);
	}

	function inicializar_jugador(p_oj)
	{
			p_oj.clave=0;
		    p_oj.nick="";
			p_oj.robot=false;
			p_oj.mesa=0;
			p_oj.mirando=false;
			p_oj.silla=0;
			p_oj.cara=0;
			p_oj.color=0;
			p_oj.estado=0;
			p_oj.moderador=false;
			p_oj.invisible=false;
			p_oj.licenciado=false;
			p_oj.principiante=false;
			p_oj.avatar_propio=false;
			p_oj.tiene_trofeos=false;
			p_oj.nivel_torneos=0;
			p_oj.nivel_riqueza=0;
			p_oj.lng="es";
			p_oj.id_facebook="";

	}
	function inicializar_mesa(p_omesa)
	{
		p_omesa.n_mesa=0;
	    p_omesa.situacion=0;
	    p_omesa.obj_mesa=null; 
	}
	function procesar_enum_almacen(p_mensa)
	{
			var t_pos,t_clave,t_saldo,t_narticulos,t_n;

			t_pos=0
			t_clave = myval(p_mensa.substr(t_pos, 30));
			t_pos+=30;
			t_saldo = gd(p_mensa.substr(t_pos, 8))
			t_pos+=8;
			t_narticulos = myval(p_mensa.substr(t_pos, 4));
			t_pos+=4;
			t_hash=new hash;
			
			for(t_n=1;t_n<=t_narticulos;t_n++)
			{
				t_oelem= new class_elem_almacen();
				t_oelem.arclave = myval(p_mensa.substr(t_pos, 30));
				t_pos+=30;
				t_oelem.alcanti = myval(p_mensa.substr(t_pos, 8));
				t_pos+=8;
				t_oelem.arprecio = myval(p_mensa.substr(t_pos, 8));
				t_pos+=8;
				t_oelem.tot_precio = myval(p_mensa.substr(t_pos, 8));
				t_pos+=8;
				t_oelem.arnombre = trim(p_mensa.substr(t_pos, 60));
				t_pos+=60;
				if(t_oelem.arclave)	t_hash.setItem(t_oelem.arclave,t_oelem);						
			}
	        var param=[
	        {hash:t_hash,clave_jugador:t_clave,saldo:t_saldo}];			
	        self.disparar_evento(self,"enum_almacen",param);			
	}
	function procesar_enum_tienda(p_mensa)
	{
			var t_pos,t_saldo,t_almacen,t_narticulos,t_n;

			t_pos=0
			t_narticulos = myval(p_mensa.substr(t_pos, 4));
			t_pos+=4;
			t_hash=new hash;
			t_almacen=0;
			t_saldo=0;
			for(t_n=1;t_n<=t_narticulos;t_n++)
			{
				t_saldo = gd(p_mensa.substr(t_pos, 8))
				t_pos+=8;
				t_almacen = gd(p_mensa.substr(t_pos, 8))
				t_pos+=8;
				t_oelem= new class_elem_almacen();
				t_oelem.arclave = myval(p_mensa.substr(t_pos, 30));
				t_pos+=30;
				t_oelem.arprecio = myval(p_mensa.substr(t_pos, 8));
				t_pos+=8;
				t_oelem.arnombre = trim(p_mensa.substr(t_pos, 40));
				t_pos+=40;
				t_hash.setItem(t_n,t_oelem);						
			}
	        var param=[
	        {hash:t_hash,saldo:t_saldo,almacen:t_almacen}];			
	        self.disparar_evento(self,"enum_tienda",param);			
	}
	function procesar_penalizar_jugador(p_mensa)
	{
		var t_pos,t_clave;

			t_pos=0
			t_clave = myval(p_mensa.substr(t_pos, 30));
			t_pos+=30;

			if(!oglobal.hash_jugadores.hasItem(t_clave)) return;
			t_oj = oglobal.hash_jugadores.items[t_clave];

	        var param=[
	        {oj:t_oj}];			
	        self.disparar_evento(self,"penalizar_jugador",param);	
	}
	function procesar_configuracion_jugador(p_mensa)
	{
		var t_pos,t_clave,t_cara,t_color;

			t_pos=0
			t_clave = myval(p_mensa.substr(t_pos, 30));
			t_pos+=30;
			if(!oglobal.hash_jugadores.hasItem(t_clave)) return;
			t_oj = oglobal.hash_jugadores.items[t_clave];
			t_cara = myval(p_mensa.substr(t_pos, 6));
			t_pos+=6;
			t_color = myval(p_mensa.substr(t_pos, 30));
			t_pos+=30;
			t_oj.cara=t_cara; 
			t_oj.color=t_color; 
			oglobal.hash_jugadores.setItem(t_oj.clave,t_oj);
	        var param=[
	        {oj:t_oj}];			
	        self.disparar_evento(self,"configurar_jugador",param);	
		
	}
	function procesar_mensaje_server_personalizado(p_mensa)
	{
		var t_segundos,t_txt;
		t_pos=0
		t_segundos = myval(p_mensa.substr(t_pos, 3));
		t_pos+=3;
		t_txt = p_mensa.substring(t_pos);

		var t_dialogo = Titanium.UI.createAlertDialog({
		    title: oglobal.titulo,
		    message: t_txt,
	    	buttonNames: [L("aceptar",'Aceptar')]		    
		});//aqui
		
		if(t_segundos!=0)
		{
			var t_timer=setInterval(function() {
				clearInterval(t_timer);
				t_timer=0;
				if(t_dialogo) t_dialogo.hide();
				t_dialogo=null;
			}
			,1000*t_segundos);			
		}		
		t_dialogo.show();		
	}
	function procesar_open_web(p_mensa)
	{
		var t_len,t_url;
		t_pos=0
		t_len = myval(p_mensa.substr(t_pos, 3));
		t_pos+=3;
		t_url = p_mensa.substr(t_pos,t_len);
		t_pos+=t_len;
		if(!oglobal.dejar_pendiente_url)
		{
			open_web(t_url);
		}
		else oglobal.url_pendiente=t_url;		
	}
	function procesar_partida_ganada_perdida(p_mensa)
	{
		var t_pos=0
		var t_ganada = iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
		t_pos+=3;
        var param=[
        {ganada:t_ganada}];			
        self.disparar_evento(self,"partida_ganada_perdida",param);	
		
	}
	function procesar_mirones_notificar_te_miran(p_mensa) 
	{
		var t_pos=0
		var t_clave_miron =myval(p_mensa.substr(t_pos, 30));
		t_pos+=30;
		var t_en_mi_silla=iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);		
		t_pos+=1;
		var t_clave_mirado =myval(p_mensa.substr(t_pos, 30));
		t_pos+=30;
        var param=[
        {miron:t_clave_miron,mirado:t_clave_mirado,misilla:t_en_mi_silla}];			
        self.disparar_evento(self,"notificar_miron",param);	
		
	}
	function procesar_mirones_notificar_te_dejan_de_miran(p_mensa)
	{
		var t_pos=0
		var t_clave_miron =myval(p_mensa.substr(t_pos, 30));
		t_pos+=30;
        var param=[
        {miron:t_clave_miron}];			
        self.disparar_evento(self,"notificar_salida_miron",param);			
	}
	function procesar_invitar_a_jugar(p_mensa)
	{
		var t_pos=0
		var t_clave =myval(p_mensa.substr(t_pos, 30));
		t_pos+=30;
        var param=[
        {clave:t_clave}];			
        self.disparar_evento(self,"invitado_a_jugar",param);					
	}
	function procesar_walki(p_mensa)
	{
		var t_pos=0
		var t_clave =myval(p_mensa.substr(t_pos, 30));
		t_pos+=30;
		var t_url=p_mensa.substr(t_pos)
        var param=[
        {clave:t_clave,url:t_url}];			
        self.disparar_evento(self,"walki",param);					
	}
	function procesar_enum_amigos(p_mensa)
	{
		var t_pos,t_n_amigos,t_hash,t_n;
			t_pos=0
			t_n_amigos = myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;
			
			t_hash=new hash;
			
			for(t_n=1;t_n<=t_n_amigos;t_n++)
			{
				t_oelem= new class_amigo();
				t_oelem.clave = myval(p_mensa.substr(t_pos, 10));
				t_pos+=10;
				t_oelem.nick =trim(p_mensa.substr(t_pos, 30));
				t_pos+=30;
				t_oelem.tipo = myval(p_mensa.substr(t_pos, 2));
				t_pos+=2;
				t_oelem.clave_salon = myval(p_mensa.substr(t_pos, 10));
				t_pos+=10;
				t_oelem.nombre_salon = trim(p_mensa.substr(t_pos, 40));
				t_pos+=40;
				t_oelem.estado = myval(p_mensa.substr(t_pos, 3));
				t_pos+=3;
				t_oelem.mesa = myval(p_mensa.substr(t_pos, 2));
				t_pos+=2;
				t_oelem.silla = myval(p_mensa.substr(t_pos, 2));
				t_pos+=2;
				t_oelem.cara = myval(p_mensa.substr(t_pos, 6));
				t_pos+=6;
				t_oelem.id_facebook = trim(p_mensa.substr(t_pos, 20));
				t_pos+=20;
				t_hash.setItem(t_n,t_oelem);						
			}
	        var param=[
	        {hash:t_hash}];			
	        self.disparar_evento(self,"enum_amigos",param);			
	}
	this.avisar_moderador = function()
	{
		var t_mensa;
		t_mensa = fid(k_men_avisar_moderador);
		self.sock_enviar(t_mensa);		
	};
	this.locutorio_crear=function()
	{
		var t_mensa;
		t_mensa = fid(k_men_locutorio_crear);
        t_mensa += padr(oglobal.clave_usuario.toString(),30,' ');
        t_mensa+=padr(oglobal.id_profile_facebook,20," ");
		self.sock_enviar(t_mensa);				
	};
	function procesar_locutorio_crear(p_mensa)
	{
		var t_id_locutorio,t_cl_creador;
        var t_pos;
        t_pos = 0;
        var t_ol;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
        t_cl_creador = myval(p_mensa.substr(t_pos, 10));
        t_pos += 10;
        var t_nick_creador = trim(p_mensa.substr(t_pos, 30));
        t_pos += 30;
		if(oglobal.hash_locu.hasItem(t_id_locutorio)==true)
		{
			t_ol = oglobal.hash_locu.items[t_id_locutorio];
		}
		else
		{
            t_ol = new class_locutorio();
			inicializar_locutorio(t_ol);   
			t_ol.id=t_id_locutorio;
			t_ol.creador=t_cl_creador;
			t_ol.nick_creador=t_nick_creador;
            oglobal.hash_locu.setItem(t_ol.id,t_ol);			         				
		}
        var param=[
        {olocu:t_ol}];
        self.disparar_evento(self,"locutorio_creado",param);
	}
	function inicializar_locutorio(p_oj)
	{
			p_oj.id=0;
		    p_oj.creador=0;
		    p_oj.nick_creador="";
		    p_oj.hash_usuarios=new hash;
		    
	}
	this.notificar_chat_locutorio=function(p_id_locutorio,p_texto)
	{
		var t_mensa;
		t_mensa = fid(k_men_locutorio_chat);
        t_mensa += padr(p_id_locutorio.toString(),6,' ');
        t_mensa += padr(oglobal.clave_usuario.toString(),10,' ');
        t_mensa+=p_texto;
		self.sock_enviar(t_mensa);				
		
	};	
	this.locutorio_enumerar_presentes=function(p_id_locutorio)
	{
		var t_mensa;
		t_mensa = fid(k_men_locutorio_enumerar_presentes);
        t_mensa += padr(p_id_locutorio.toString(),6,' ');
		self.sock_enviar(t_mensa);						
	};
	function procesar_locutorio_enumerar_presentes(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        var t_ol;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
        var t_n_presentes = myval(p_mensa.substr(t_pos, 3));
        t_pos += 3;
		if(!oglobal.hash_locu.hasItem(t_id_locutorio))
		{
			return;
		}
		var t_ol = oglobal.hash_locu.items[t_id_locutorio];
		var t_op;
		for(var t_n=1;t_n<=t_n_presentes;t_n++)
		{
            t_op = new class_locutorio_usuario();
            t_op.clave=myval(p_mensa.substr(t_pos, 10));
            t_pos+=10;
            t_op.nick=trim(p_mensa.substr(t_pos, 30));
            t_pos+=30;
            t_op.lng=trim(p_mensa.substr(t_pos, 3));
            t_pos+=3;
            t_op.cara=myval(p_mensa.substr(t_pos, 6));
            t_pos+=6;
            t_op.id_facebook=trim(p_mensa.substr(t_pos, 20));
            t_pos+=20;
            t_op.color=myval(p_mensa.substr(t_pos, 30));
            t_pos+=30;
            t_op.avatar_propio=true;
            t_op.creador=iif(t_ol.creador==t_op.clave,true,false);
			if(!t_ol.hash_usuarios.hasItem(t_op.clave))
			{
            	t_ol.hash_usuarios.setItem(t_op.clave,t_op);			         								
			}
			else
			{
            	t_ol.hash_usuarios.setItem(t_op.clave,t_op);			         								
			}
			oglobal.hash_locu.setItem(t_ol.id,t_ol);
	        var param=[
	        {opresente:t_op}];
	        self.disparar_evento(self,"locutorio_presente_enumerado",param);		            
		}
        t_op = new class_locutorio_usuario();
        t_op.clave=0;
        var param=[
        {opresente:t_op}];
        self.disparar_evento(self,"locutorio_presente_enumerado",param);		            
		
	}
	function procesar_locutorio_chat(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        var t_ol;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
		if(!oglobal.hash_locu.hasItem(t_id_locutorio))
		{
			return;
		}
        t_pos += 6;
        var t_clave = myval(p_mensa.substr(t_pos, 10));
        t_pos += 10;
        var t_texto = trim(p_mensa.substr(t_pos));        
		var t_ol = oglobal.hash_locu.items[t_id_locutorio];
        var param=[
        {olocu:t_ol,clave:t_clave,texto:t_texto}];
        self.disparar_evento(self,"locutorio_chat",param);		            				
	}
	this.locutorio_invitar=function(p_id,p_clave)
	{
		var t_mensa;
		t_mensa = fid(k_men_locutorio_invitar);
        t_mensa += padr(p_id.toString(),6,' ');
        t_mensa += padr(oglobal.clave_usuario.toString(),10,' ');
        t_mensa += padr(p_clave.toString(),10,' ');
		self.sock_enviar(t_mensa);						
	};
	function procesar_locutorio_entrada(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
		if(!oglobal.hash_locu.hasItem(t_id_locutorio))
		{
			return;
		}
		var t_ol = oglobal.hash_locu.items[t_id_locutorio];
        t_pos += 6;
    	t_op = new class_locutorio_usuario();
	    t_op.clave=myval(p_mensa.substr(t_pos, 10));
	    t_pos+=10;
	    t_op.nick=trim(p_mensa.substr(t_pos, 30));
	    t_pos+=30;
	    t_op.lng=trim(p_mensa.substr(t_pos, 3));
	    t_pos+=3;
	    t_op.cara=myval(p_mensa.substr(t_pos, 6));
	    t_pos+=6;
	    t_op.id_facebook=trim(p_mensa.substr(t_pos, 20));
	    t_pos+=20;
	    t_op.color=myval(p_mensa.substr(t_pos, 30));
	    t_pos+=30;
	    t_op.avatar_propio=true;
	    t_op.creador=iif(t_ol.creador==t_op.clave,true,false);
		if(!t_ol.hash_usuarios.hasItem(t_op.clave))
		{
	    	t_ol.hash_usuarios.setItem(t_op.clave,t_op);			         								
		}
		else
		{
	    	t_ol.hash_usuarios.setItem(t_op.clave,t_op);			         								
		}
		oglobal.hash_locu.setItem(t_ol.id,t_ol);
	    var param=[
	    {opresente:t_op}];
	    self.disparar_evento(self,"locutorio_entrada",param);	
	}
	function procesar_locutorio_salida(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
		if(!oglobal.hash_locu.hasItem(t_id_locutorio))
		{
			return;
		}
		var t_ol = oglobal.hash_locu.items[t_id_locutorio];
    	var t_clave= myval(p_mensa.substr(t_pos, 10));
    	t_pos+=10;
		if(!t_ol.hash_usuarios.hasItem(t_clave)) return;
		var t_op=t_ol.hash_usuarios.items[t_clave];
	    var param=[
	    {opresente:t_op}];
	    self.disparar_evento(self,"locutorio_salida",param);	
    	t_ol.hash_usuarios.removeItem(t_clave);
		oglobal.hash_locu.setItem(t_ol.id,t_ol);
	}
	function procesar_locutorio_entrar_invitado(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
		if(!oglobal.hash_locu.hasItem(t_id_locutorio))
		{
			return;
		}
		var t_ol = oglobal.hash_locu.items[t_id_locutorio];
    	var t_clave_invitador= myval(p_mensa.substr(t_pos, 10));
    	t_pos+=10;
    	var t_nick_invitador= myval(p_mensa.substr(t_pos, 30));
    	t_pos+=30;
    	var t_clave_invitado= myval(p_mensa.substr(t_pos, 10));
    	t_pos+=10;
    	var t_nick_invitado= myval(p_mensa.substr(t_pos, 30));
    	t_pos+=30;		
	}
	function procesar_locutorio_mensaje_server_recibido(p_mensa)
	{
					
        var t_latente,t_texto;

        t_pos = 0;
        t_latente = iif(myval(p_mensa.substr(t_pos, 1)) == 1 , true, false);
        t_pos++;
        t_texto=trim(p_mensa.substring(t_pos));
        
        var param=[
        {texto:t_texto}];
        self.disparar_evento(self,"locutorio_mensaje_server",param);

	}
	this.locutorio_salir=function(p_id)
	{

		if(oglobal.hash_locu.hasItem(p_id))
		{
			var t_ol=oglobal.hash_locu.items[p_id];
			t_ol.hash_usuarios=null;
			oglobal.hash_locu.removeItem(p_id);
		}
		var t_mensa;
		t_mensa = fid(k_men_locutorio_salir);
        t_mensa += padr(p_id.toString(),6,' ');
		self.sock_enviar(t_mensa);								
	};
	function procesar_locutorio_invitado(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
    	var t_clave_invitador= myval(p_mensa.substr(t_pos, 10));
    	t_pos+=10;
    	var t_nick_invitador= trim(p_mensa.substr(t_pos, 30));
    	t_pos+=30;
    	var t_clave_invitado= myval(p_mensa.substr(t_pos, 10));
    	t_pos+=10;
    	var t_clave_creador= myval(p_mensa.substr(t_pos, 10));
    	t_pos+=10;
    	var t_nick_creador= trim(p_mensa.substr(t_pos, 30));
    	t_pos+=30;
        var param=[
        {nick_invitador:t_nick_invitador,clave_invitador:t_clave_invitador,clave_creador:t_clave_creador,nick_creador:t_nick_creador,id_locu:t_id_locutorio}];
        self.disparar_evento(self,"locutorio_invitado",param);
    	
	}
	this.notificar_locutorio_aceptar_invitacion=function(p_aceptar,p_id)
	{
		var t_mensa = fid(k_men_locutorio_aceptar_invitacion);
        t_mensa += padr(p_id.toString(),6,' ');
        t_mensa += padr(oglobal.clave_usuario.toString(),10,' ');
        t_mensa += padr(oglobal.id_profile_facebook,20,' ');
        t_mensa += iif(p_aceptar,"1","0");
		self.sock_enviar(t_mensa);										
	};
	this.get_nick_creador_locutorio=function(p_id)
	{
		if(!oglobal.hash_locu.hasItem(p_id))
		{
			return "";
		}
		var t_ol = oglobal.hash_locu.items[p_id];
		var t_cl_creador=t_ol.creador;
		if(!t_ol.hash_usuarios.hasItem(t_cl_creador)) return "";
		var t_op=t_ol.hash_usuarios.items[t_cl_creador];
		return t_op.nick;
		
	};
	function procesar_locutorio_expulsado(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
		if(!oglobal.hash_locu.hasItem(t_id_locutorio))
		{
			return;
		}
		var t_ol = oglobal.hash_locu.items[t_id_locutorio];
    	var t_clave= myval(p_mensa.substr(t_pos, 10));
    	t_pos+=10;
		if(!t_ol.hash_usuarios.hasItem(t_clave)) return;
		var t_op=t_ol.hash_usuarios.items[t_clave];
	    var param=[
	    {opresente:t_op}];
	    self.disparar_evento(self,"locutorio_expulsado",param);	
    	//t_ol.hash_usuarios.removeItem(t_clave);
		//oglobal.hash_locu.setItem(t_ol.id,t_ol);
	}
	this.notificar_locutorio_expulsar=function(p_id,p_clave)
	{
		var t_mensa = fid(k_men_locutorio_expulsar);
        t_mensa += padr(p_id.toString(),6,' ');
        t_mensa += padr(p_clave.toString(),10,' ');
		self.sock_enviar(t_mensa);												
	};
	function procesar_locutorio_walki(p_mensa)
	{
		var t_id_locutorio;
        var t_pos;
        t_pos = 0;
        t_id_locutorio = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
		if(!oglobal.hash_locu.hasItem(t_id_locutorio))
		{
			return;
		}
        var t_clave= myval(p_mensa.substr(t_pos, 30));
        t_pos+=30;
        var t_url=trim(p_mensa.substr(t_pos));
	    var param=[
	    {clave:t_clave,url:t_url}];
	    self.disparar_evento(self,"locutorio_walki",param);					
	}
	function procesar_status(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_estado_partida = myval(p_mensa.substr(t_pos, 1));
        t_pos += 1;
        var t_num_cartones_en_juego = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
        var t_coste_carton = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
        var t_participantes = myval(p_mensa.substr(t_pos, 6));
        t_pos += 6;
        var t_premio_bingo = myval(p_mensa.substr(t_pos, 12));
        t_pos += 12;
        var t_premio_linea2 = myval(p_mensa.substr(t_pos, 12));
        t_pos += 12;
        var t_premio_linea = myval(p_mensa.substr(t_pos, 12));
        t_pos += 12;
        var t_bote = myval(p_mensa.substr(t_pos, 12));
        t_pos += 12;
        var t_bolas_maximas_bote = myval(p_mensa.substr(t_pos, 2));
        t_pos += 2;
        var t_secuencia_bola = myval(p_mensa.substr(t_pos, 2));
        t_pos += 2;
        var t_max_bolas = myval(p_mensa.substr(t_pos, 2));
        t_pos += 2;
        var t_ganador_linea_nick = trim(p_mensa.substr(t_pos, 15));
        t_pos += 15;
        var t_ganador_doble_linea_nick = trim(p_mensa.substr(t_pos, 15));
        t_pos += 15;
        var t_ganador_bingo_nick = trim(p_mensa.substr(t_pos, 15));
        t_pos += 15;
	    var param=[
	    {estado_partida:t_estado_partida,
	    	num_cartones_en_juego:t_num_cartones_en_juego,
	    	coste_carton:t_coste_carton,
	    	participantes:t_participantes,
	    	premio_bingo:t_premio_bingo,
			premio_linea2:t_premio_linea2,
			premio_linea:t_premio_linea,
			bote:t_bote,
			bolas_maximas_bote:t_bolas_maximas_bote,
			secuencia_bola:t_secuencia_bola,
			max_bolas:t_max_bolas,
			ganador_linea_nick:t_ganador_linea_nick,
			ganador_doble_linea_nick:t_ganador_doble_linea_nick,
			ganador_bingo_nick:t_ganador_bingo_nick																    	
	    	}];
	    self.disparar_evento(self,"status",param);					
		
	}
	function procesar_tiempo_inicio_siguiente_bingo(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_horas = myval(p_mensa.substr(t_pos, 2));
		t_pos+=2;
        var t_minutos = myval(p_mensa.substr(t_pos, 2));
		t_pos+=2;
        var t_segundos = myval(p_mensa.substr(t_pos, 2));
		t_pos+=2;
	    var param=[
	    {horas:t_horas,minutos:t_minutos,segundos:t_segundos}];
	    self.disparar_evento(self,"tiempo_inicio_siguiente_bingo",param);						    
	}
	function procesar_notificar_cartones_posibles(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_a_cartones= new Array();
        
        var t_n_cartones = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_mostrar = iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
        t_pos+=1;
		for(var t_carton=1;t_carton<=t_n_cartones;t_carton++)
		{
			var t_seleccionado=iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
			t_pos+=1;
			var t_color1=myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;
			var t_color2=myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;
			var t_color3=myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;
			var t_n_numeros=myval(p_mensa.substr(t_pos, 2));
			t_pos+=2;
			t_a_cartones[t_carton]=[];
			t_a_cartones[t_carton].numeros=new Array();
			t_a_cartones[t_carton].color1=t_color1;
			t_a_cartones[t_carton].color2=t_color2;
			t_a_cartones[t_carton].color3=t_color3;
			t_a_cartones[t_carton].seleccionado=t_seleccionado;
			t_a_cartones[t_carton].n_numeros=t_n_numeros;
			
			for(var t_n=1;t_n<=t_n_numeros;t_n++)
			{
				var t_numero=myval(p_mensa.substr(t_pos, 2));
				t_a_cartones[t_carton].numeros[t_n]=t_numero;
				t_pos+=2;
			}
			
		}
	    var param=[
	    {n_cartones:t_n_cartones,mostrar:t_mostrar,cartones:t_a_cartones}];
	    self.disparar_evento(self,"cartones_posibles",param);						    
	  
	}
	this.notificar_carton_seleccionado=function(p_carton)
	{
		var t_mensa = fid(k_men_carton_seleccionado);
        t_mensa += padr(p_carton.toString(),2,' ');
        self.sock_enviar(t_mensa);
	};
	function procesar_carton_seleccionado(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_numero = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_seleccionado=iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
        t_pos++;
        var t_n_seleccionados=myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_por_compra=iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
        t_pos++;
        
	    var param=[
	    {num_carton:t_numero,num_seleccionados:t_n_seleccionados,seleccionado:t_seleccionado,por_compra:t_por_compra}];
	    self.disparar_evento(self,"carton_seleccionado",param);						    
		
	}	
	function procesar_bola_sacada(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_seq = myval(p_mensa.substr(t_pos, 3));
        t_pos+=3;
        var t_numero = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_color = myval(p_mensa.substr(t_pos, 1));
        t_pos+=1;
        var t_num_antiguo = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
	    var param=[
	    {seq:t_seq,numero:t_numero,color:t_color,numero_antiguo:t_num_antiguo}];
	    self.disparar_evento(self,"bola_sacada",param);						    
		
	}
	this.solicitar_configuracion=function()
	{
		var t_mensa = fid(k_men_recibir_configuracion);
        self.sock_enviar(t_mensa);		
	};
	function procesar_bingo_iniciado_general(p_mensa)
	{
	    var param=[{general:true}];
	    self.disparar_evento(self,"bingo_iniciado",param);						    		
	}	
	function procesar_bingo_iniciado_participante(p_mensa)
	{
	    var param=[{general:false}];
	    self.disparar_evento(self,"bingo_iniciado",param);						    		
	}
	function procesar_reproducir_tts(p_mensa){
        var t_pos;
        t_pos = 0;
        var t_txt = p_mensa.substr(t_pos);
		tts(t_txt);
	}	
	function procesar_notificar_cartones_elegidos(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_a_cartones= new Array();
        
        var t_n_cartones = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
		for(var t_carton=1;t_carton<=t_n_cartones;t_carton++)
		{
			var t_color1=myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;
			var t_color2=myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;
			var t_color3=myval(p_mensa.substr(t_pos, 3));
			t_pos+=3;
			var t_n_numeros=myval(p_mensa.substr(t_pos, 2));
			t_pos+=2;
			t_a_cartones[t_carton]=[];
			t_a_cartones[t_carton].numeros=new Array();
			t_a_cartones[t_carton].color1=t_color1;
			t_a_cartones[t_carton].color2=t_color2;
			t_a_cartones[t_carton].color3=t_color3;
			t_a_cartones[t_carton].n_numeros=t_n_numeros;
			t_a_cartones[t_carton].numero=t_carton;
			
			for(var t_n=1;t_n<=t_n_numeros;t_n++)
			{
				var t_numero=myval(p_mensa.substr(t_pos, 2));
				t_a_cartones[t_carton].numeros[t_n]=t_numero;
				t_pos+=2;
				var t_seleccionado=iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
				t_a_cartones[t_carton].numeros[t_n]={numero:t_numero,marcado:t_seleccionado};
				t_pos+=1;
			}
			
		}
	    var param=[
	    {n_cartones:t_n_cartones,cartones:t_a_cartones}];
	    self.disparar_evento(self,"cartones_elegidos",param);						    
	  
	}
	this.notificar_numero_marcado=function(p_carton,p_numero)
	{
		var t_mensa = fid(k_men_marcar_numero);
        t_mensa += padr(p_carton.toString(),2,' ');
        t_mensa += padr(p_numero.toString(),2,' ');
        self.sock_enviar(t_mensa);
		
	};
	function procesar_marcar_numero(p_mensa)
	{
        var t_pos;
        t_pos = 0;        
        var t_carton = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_numero = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_incorrecto = iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
        t_pos+=1;
	    var param=[
	    {carton:t_carton,numero:t_numero,incorrecto:t_incorrecto}];
	    self.disparar_evento(self,"numero_marcado",param);						    		
	}
	function procesar_fin_bingo(p_mensa)
	{
        var t_pos;
        t_pos = 0;        
        var t_cancelado = iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
        t_pos+=1;
	    var param=[
	    {cancelado:t_cancelado}];
	    self.disparar_evento(self,"fin_bingo",param);						    		
		
	}
	this.notificar_mismos_cartones=function()
	{
		var t_mensa = fid(k_men_notificar_mismos_cartones);
        self.sock_enviar(t_mensa);
		
	};
	function procesar_ganador(p_tipo,p_mensa)
	{
        var t_pos;
        t_pos = 0;        
        var t_clave = myval(p_mensa.substr(t_pos, 30));
        t_pos+=30;
        var t_premio = myval(p_mensa.substr(t_pos, 8));
        t_pos+=8;
	    var param=[
	    {tipo:p_tipo,clave:t_clave,premio:t_premio}];
	    self.disparar_evento(self,"notificar_ganador",param);						    		
		
	}
	function procesar_notificar_numeros_salidos(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_n_numeros = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_a=new Array();
        for(var t_n=1;t_n<=t_n_numeros;t_n++)
        {
	        var t_numero=myval(p_mensa.substr(t_pos, 2));
	        t_pos+=2;
	        var t_reciente=iif(myval(p_mensa.substr(t_pos, 1))==1,true,false);
	        t_pos+=1;      
	        t_a[t_n]={numero:t_numero,reciente:t_reciente};  	
        }
        
	    var param=[
	    {n_numeros:t_n_numeros,a_numeros:t_a}];
	    self.disparar_evento(self,"notificar_numeros_salidos",param);						    
		
	}
	function procesar_candidatos(p_mensa)
	{
        var t_pos;
        t_pos = 0;
        var t_n_candidatos = myval(p_mensa.substr(t_pos, 2));
        t_pos+=2;
        var t_a=new Array();
        for(var t_n=1;t_n<=t_n_candidatos;t_n++)
        {
	        var t_clave=myval(p_mensa.substr(t_pos, 6));
	        t_pos+=6;
	        var t_faltan=myval(p_mensa.substr(t_pos, 1));
	        t_pos+=1;
	        t_a[t_n]={clave:t_clave,faltan:t_faltan};  	
        }
        
	    var param=[
	    {n_candidatos:t_n_candidatos,a_candidatos:t_a}];
	    self.disparar_evento(self,"candidatos",param);						    
		
	}
	function procesar_sonido_file(p_mensa){
        var t_pos;
        t_pos = 0;
        var t_file = trim(p_mensa.substr(t_pos, 30));
        t_pos+=30;
        var t_canal = myval(p_mensa.substr(t_pos));
		sonido_bingo(t_file);
		
	}
	function procesar_superbola(p_mensa){
        var t_pos;
        t_pos = 0;
        var t_clave= myval(p_mensa.substr(t_pos, 30));
        t_pos+=30;
        var t_numero = myval(p_mensa.substr(t_pos,2));
        t_pos+=2;
        var t_color = myval(p_mensa.substr(t_pos,2));
        t_pos+=2;
        var t_mensaje = p_mensa.substr(t_pos);
	    var param=[
	    {clave:t_clave,numero:t_numero,color:t_color,mensaje:t_mensaje}];
	    self.disparar_evento(self,"superbola",param);						    
	}
	this.notificar_seleccionar_n_cartones=function(p_num)
	{
		var t_mensa = fid(k_men_seleccionar_n_cartones);
        t_mensa += padr(p_num.toString(),2,' ');
        self.sock_enviar(t_mensa);		
	};
	this.notificar_seleccionar_ninguno=function()
	{
		var t_mensa = fid(k_men_seleccionar_ninguno);
        self.sock_enviar(t_mensa);		
	};
	this.notificar_renovar_cartones=function(){
		var t_mensa = fid(k_men_notificar_renovar_cartones);
        self.sock_enviar(t_mensa);		
	};
}
module.exports =obj_logica;