function win_lista_jugadores()
{
	var win;	
	var ofun_invitar;
	
	function liberar()
	{
		liberar_recur(win);
		win=null;		
		ofun_invitar=null;
	}
	function sortfunction(a, b){
	//Compare "a" and "b" in some fashion, and return -1, 0, or 1
		if(a.nick>b.nick) return 1;
		if(a.nick<b.nick) return -1;
		if(a.nick==b.nick) return 0;
	}
	this.init=function(p_fun_invitar)
	{		 
		var t_top;
		var t_num;
		ofun_invitar=p_fun_invitar;
		t_num=oglobal.hash_jugadores.length;
		win = Titanium.UI.createWindow({  
			title:t_num.toString()+" "+L("jugadores","Jugadores"),
			zindex:10000,
			navBarHidden:false,
			orientationModes:[Ti.UI.PORTRAIT,Ti.UI.UPSIDE_PORTRAIT],			
			backgroundColor:'#000000'
			});
		aspecto_ventana(win);
		win.addEventListener('close', function() {
				liberar();    			
				});
		var t_array=oglobal.hash_jugadores.items.slice(0);
		win.addEventListener('focus', function() {
  				ocultar_actividad();
				});
		t_array.sort(sortfunction);

		var t_color=new Array()
		var t_estado=new Array()
		t_color[k_estado_jug_libre] = "#88068d"
		t_color[k_estado_jug_ocupado] = "#88068d"
		t_color[k_estado_jug_jugando] = "#dddd20"
		t_color[k_estado_jug_caido] = "#000000"
		t_color[k_estado_jug_mirando] = "#f78907"
		t_color[k_estado_jug_latente] = "#02dccf"
		
		t_estado[k_estado_jug_libre] = L("situ_disponible","Disponible")
		t_estado[k_estado_jug_ocupado] = L("situ_ocupado","Ocupado")
		t_estado[k_estado_jug_jugando] = L("situ_jugando","Jugando")
		t_estado[k_estado_jug_caido] = L("situ_caido","Caído")
		t_estado[k_estado_jug_mirando] = L("situ_mirando","Mirando")
		t_estado[k_estado_jug_latente] = L("situ_ausente","Ausente")

		var table = Titanium.UI.createScrollView({
			contentWidth:'auto',
			contentHeight:'auto',
			top:0,
			left:0,
			right:0,
			bottom:0,
			showVerticalScrollIndicator:true
			});	

		t_top=0;
		for (var i = 0; i < t_num; i++) 
		{     
			var t_oj=t_array[i];
			var t_cara;
			if(t_oj.mesa)
			{
				t_color[k_estado_jug_libre] = "#096b09";
			}
			else
			{
				t_color[k_estado_jug_libre] = "#2ebd2e";
			}
			t_fore="#ffffff";
			if(t_oj.estado==k_estado_jug_jugando) t_fore="#444444";
			var row = Ti.UI.createView({
				//className:"juga",
				
				top:t_top,left:0,right:0,
				height:factor(48),
				backgroundColor:t_color[t_oj.estado]
			});
			row.clave=t_oj.clave;
			row.addEventListener('longpress',function(e)
			{
				abrir_infojugador(e);
			}); 
			
			row.addEventListener('click',function(e) 
			{
				abrir_infojugador(e);
			});
			var t_ava=Titanium.UI.createImageView(
				{	
					 left:0,top:0,
					 width:factor(48),
					 height:factor(48)
				});
			t_ava.jugador=t_oj;	
			get_img_cara(t_ava);				
			t_ava.clave=t_oj.clave;
		    var label = Ti.UI.createLabel(
		    {
		    	left: factor(70),
		    	top:0,
		        font:{fontSize:factor(15),fontWeight:'bold',fontFamily:'Helvetica Neue'},
		        color: t_fore,
		        textAlign:"left",
		     
		        text: t_oj.nick   		        
		    });
		    label.clave=t_oj.clave;
		    
		    
		    
		    var t_mesa = Ti.UI.createLabel(
		    {
		    	left: factor(70),
		    	bottom:0,
		        font:{fontSize:factor(12),fontWeight:'bold',fontFamily:'Helvetica Neue'},
		        color: t_fore,
		        textAlign:"left",
		        text:iif(t_oj.mesa==0,"",L("mesa","Mesa")+": "+t_oj.mesa.toString()+" "+L("silla","Silla")+": "+t_oj.silla.toString())+" ("+t_estado[t_oj.estado]+")"   		        
		    });
			t_mesa.clave=t_oj.clave;
	        row.add(label);
	        row.add(t_mesa);
	        row.add(t_ava);
	        
	        //row.leftImage=t_url;
	        table.add(row);
	        t_top+=factor(48)+1;
	        row=null;
		}   
		// now assign that array to the table's data property to add those objects as rows 
		
		win.add(table);
		if(os_ios())
		{		
			var b_cerrar2=Titanium.UI.createButton({  
					title:L("volver",'Volver')
				});  
			win.leftNavButton=b_cerrar2;
			b_cerrar2.addEventListener('click', function(e){
							sonido("boton.wav");

				cerrar();
			}); 
		}
		t_array=null;
		return win;
	};
	function cerrar()
	{
		if(win) win.close();
	}
	function abrir_infojugador(e)
	{
		sonido("boton.wav");
	    	mostrar_actividad(win,L("cargando_informacion_jugador","Cargando Información"),4);
		var win_informacion=require('/comun/win_informacion.js');
		var t_o=new win_informacion();			
		var w=t_o.init(e.source.clave,ofun_invitar);
		//w.open({modal:true});
		abrir_ventana(w);
		w=null;	
		t_o=null;
		ocultar_actividad();
	}
}
module.exports =win_lista_jugadores;