
function win_tienda()
{
	var win;
	var o_tienda,lsaldo;	
	var saldo;
	var saca,hash_saca;
	var valor_compra;
	function liberar()
	{
		cleanup();		
	}
	this.init=function()
	{		 
		var t_top,t_left;
		saldo=0;
		win = Titanium.UI.createWindow({  
			title:L("la_tienda","La Tienda"),
			backgroundColor:'#000000',
			orientationModes:[Ti.UI.PORTRAIT,Ti.UI.UPSIDE_PORTRAIT],			
			navBarHidden:false
			});
		aspecto_ventana(win);		

		win.addEventListener('close', function() {
				liberar();    			
				});

		t_left=0;
		t_top=0;
		lsaldo=Titanium.UI.createLabel({
			left:t_left,
			top:t_top,			
			color:'#ffffff',
			font:{fontSize:factor(14),fontWeight:'bold',fontFamily:'Helvetica Neue'},									
			width:"auto",
			text:L("saldo_disponible","Saldo disponible")+": 0$"
		});
		win.add(lsaldo);

		t_top+=factor(16);
		var l_label1=Titanium.UI.createLabel({
			right:0,
			top:t_top,			
			color:'#ffffff',
			font:{fontSize:factor(12),fontWeight:'normal',fontFamily:'Helvetica Neue'},									
			width:"auto",
			text:L("articulos_tienda","Artículos de la tienda")
		});
		win.add(l_label1);
		t_top+=factor(17);


		var t_alto_articulo=factor(80);
		var t_ancho_tienda=get_ancho_pantalla();
		var t_alto_tienda,t_alto_posible,t_alto_saca;
		var conte_tienda=require('/comun/conte_tienda.js');
		o_tienda=new conte_tienda();
		var oconte_tienda=o_tienda.init(oglobal.clave_usuario,fun_articulo_comprado,fun_cargado,t_ancho_tienda,t_alto_articulo);
		oconte_tienda.top=t_top;
		t_alto_posible=(get_alto_pantalla()-t_top)-factor(40);
		t_alto_tienda=t_alto_posible*50/100;
		oconte_tienda.height=t_alto_tienda;
		
		win.add(oconte_tienda);
		t_top+=t_alto_tienda+5;
		var l_label2=Titanium.UI.createLabel({
			right:0,
			top:t_top,			
			color:'#ffffff',
			font:{fontSize:factor(12),fontWeight:'normal',fontFamily:'Helvetica Neue'},									
			width:"auto",
			text:L("articulos_carrito","Artículos en carrito")
		});
		win.add(l_label2);
		t_top+=factor(17);

		saca= Titanium.UI.createScrollView({
				top:t_top,
				bottom:factor(40),
				backgroundColor:"#ffffff",
			    contentWidth:'auto',
			    contentHeight:'auto',
			    focusable:true,
			    touchEnabled:true,
			    borderRadius:15,
			    showVerticalScrollIndicator:true,
				showHorizontalScrollIndicator:true
			});
		win.add(saca);
				
		hash_saca=new hash;
		if(os_ios())
		{		
			var b_cerrar2=Titanium.UI.createButton({  
					title:L("volver",'Volver')
				});  
			win.leftNavButton=b_cerrar2;
			b_cerrar2.addEventListener('click', function(e){
							sonido("boton.wav");

				cerrar();
			}); 
		}		

		var b_comprar = crear_boton_imagen({  
			height:factor(40),
			//backgroundColor:"#000000",
			color:"#ffffff",
			borderRadius:15,
			bottom:0
		},"ok.png");  
		b_comprar.width="50%";
		b_comprar.left=0;
		win.add(b_comprar);
		b_comprar.addEventListener('click', function(e){
						sonido("boton.wav");

			comprar();
		});


		var b_ayuda = crear_boton_imagen(
		{	
			right:0,  
			height:factor(40),
			//backgroundColor:"#000000",
			color:"#ffffff",
			borderRadius:15,
			bottom:0
		},"ayuda.png");
		b_ayuda.width="50%";
		b_ayuda.addEventListener('click', function(e){
						sonido("boton.wav");
			open_web(url_server+"/_ayuda_tienda_movil.aspx");
		});
		win.add(b_ayuda);
		return win;
	};
	function fun_cargado(p_saldo)
	{
		saldo=p_saldo;
		lsaldo.text=L("saldo_restante","Saldo restante")+": "+formatNumber.new(saldo)+"$";
		ocultar_actividad();			
	}

	function cleanup()
	{
		win=null;
		lsaldo=null;
		saca=null;		
		if(o_tienda) o_tienda.liberar();
		o_tienda=null;
	}
	function cerrar()
	{
		if(win) win.close();
	}
	function comprar()
	{
		if(hash_saca.length==0)
		{
			var t_dialogo = Titanium.UI.createAlertDialog({
					    title: oglobal.titulo,
					    message: L("carrito_vacio","El carrito está vacío. Pulsa sobre el artículo que quieras comprar para pasarlo al carrito."),
				    	buttonNames: [L("aceptar",'Aceptar')]		    
					});
			t_dialogo.show(); 				
			return;
		}
		oglobal.ologic.compra_articulos(oglobal.clave_usuario,hash_saca);
		var t_dialogo = Titanium.UI.createAlertDialog({
				    title: oglobal.titulo,
				    message: L("compra_realizada","Compra realizada. Podrás ver tus nuevos artículos en tu almacén. Muchas gracias."),
			    	buttonNames: [L("aceptar",'Aceptar')]		    
				});
		t_dialogo.addEventListener('click', function(e)
			{
				cerrar();	 
		});

		t_dialogo.show(); 				
		
	}
	function fun_articulo_comprado(p_cl_arti,p_obj_arti)
	{
		if(p_obj_arti.arprecio>saldo)
		{
			var t_dialogo = Titanium.UI.createAlertDialog({
				    title: oglobal.titulo,
				    message: L("saldo_insuficiente","No dispones de suficiente saldo para comprar el artículo."),
			    	buttonNames: [L("aceptar",'Aceptar')]		    
				});
				t_dialogo.show();  
			return;
		}
		incrementar_saca(p_obj_arti);
		saldo-=p_obj_arti.arprecio;
		actualizar_saldo();
		sonido("snd_trin.wav");
		mostrar_saca();
				
	}
function incrementar_saca(p_obj_arti)
	{
		var t_cl,t_cl_found;
		var t_oelem;
		t_cl_found=0;
		if(!p_obj_arti) return;
		for (var t_cl in hash_saca.items) 
		{
			t_oelem=hash_saca.getItem(t_cl);
			if(!t_oelem) continue;
			if(t_oelem.arclave==p_obj_arti.arclave)
			{
				t_cl_found=t_cl;
				break;
			}
		}
		if(t_cl_found==0) // no hay ese articulo
		{
			t_oelem=new class_elem_almacen();
			t_oelem.arclave=p_obj_arti.arclave;
			t_oelem.alcanti=0;
			t_oelem.arprecio=p_obj_arti.arprecio;
			t_oelem.arnombre=p_obj_arti.arnombre;
			t_cl_found=t_oelem.arclave;
		}
		t_oelem.alcanti+=1;
		t_oelem.tot_precio=t_oelem.alcanti*t_oelem.arprecio;
		hash_saca.setItem(t_cl_found,t_oelem);
	}
	function devolver_articulo(p_clave)
	{
		var t_hash,t_oelem;
		t_hash=hash_saca;

		t_oelem=t_hash.getItem(p_clave);
		if(!t_oelem) return;
	
		// descontamos el articulo de la lista 	
		var t_cl_found,t_cl;
		t_cl_found=0;
		for (var t_cl in t_hash.items) 
		{
			t_oelem=t_hash.getItem(t_cl);
			if(t_oelem.arclave==p_clave)
			{
				t_cl_found=t_cl;
				break;
			}
		}
		if(t_cl_found==0) // no hay ese articulo
		{
			return;
		}
		t_oelem.alcanti-=1;
		if(t_oelem.alcanti<=0)
		{
			hash_saca.removeItem(t_cl_found);
		}
		else
		{
			t_oelem.tot_precio=t_oelem.alcanti*t_oelem.arprecio;
			hash_saca.setItem(t_cl_found,t_oelem);			
		}
		saldo+=t_oelem.arprecio;	
		actualizar_saldo();
		mostrar_saca();
	}
	function mostrar_saca()
	{
		var t_n,t_height_elem;
		if(saca.children)
		{
			var t_tot=saca.children.length;
		for (t_n=t_tot;t_n>=1;t_n--)
		{
			saca.remove(saca.children[t_n-1]);	
		}
		}	
		var t_num_columnas,t_ancho_columna,t_n_col;
		t_height_elem=factor(80);
		t_ancho_columna=t_height_elem;
		t_num_columnas=get_ancho_pantalla()/(t_ancho_columna+2)
		t_top_elem=4;
		t_left=0
		t_alto_sep=2;
		var t_heigh_imagen=t_height_elem-factor(20)*2-t_alto_sep
		valor_compra=0;
		t_n_col=0
		for (t_n in hash_saca.items)
		{
			t_n_col+=1;
			
			t_oelem=hash_saca.getItem(t_n);
			valor_compra+=t_oelem.tot_precio;
			t_url=url_server+"/images/articulos/objeto"+t_oelem.arclave.toString()+".jpg";			
			var view = Ti.UI.createView({
			    width:t_ancho_columna,
			    height:t_height_elem,
			    top:t_top_elem,
			    left:t_left
			});
			
			t_top=0
					
			var img = Ti.UI.createImageView({
			    top:t_top,
			    height:t_heigh_imagen,
			    image:t_url
			});
			img.id=t_n;
			img.addEventListener('click',function(e)
					{
						devolver_articulo(hash_saca.getItem(this.id).arclave);
					});

			t_top+=t_heigh_imagen+1;
		    var label1 = Ti.UI.createLabel(
		    {
		    	top: t_top,
		        font:{fontSize:factor(12),fontWeight:'bold',fontFamily:'Helvetica Neue'},
		        color: '#000000',
		        textAlign:"center",
		        width:"100%",
		        height:factor(20),
		        text:t_oelem.arnombre		        
		    });
		    t_top+=factor(20);
		    var label2 = Ti.UI.createLabel(
		    {
		    	top: t_top,
		        font:{fontSize:factor(12),fontWeight:'bold',fontFamily:'Helvetica Neue'},
		        color: '#e9a115',
		        textAlign:"center",
		        width:"100%",
		        height:factor(20),
		        text:t_oelem.alcanti.toString()+"x"+formatNumber.new(t_oelem.arprecio)+"$"		        
		    });
		    t_top+=factor(20);
		  
		    view.add(img);
		    view.add(label1);
		    view.add(label2);
			saca.add(view);
			if(t_n_col>=t_num_columnas)
			{
				t_top_elem+=t_height_elem;
				t_left=0;
				t_n_col=0;
			}
			else
			{
				t_left+=t_ancho_columna;
			}
						
		}
	}
	function actualizar_saldo()
	{
		lsaldo.text=L("saldo_disponible","Saldo disponible")+": "+formatNumber.new(saldo)+"$";		
	}	
}
module.exports =win_tienda;