
function conte_miembros_locutorio()
{
	var self;
	var view;
	var o_locutorio;
	this.liberar=function()
	{
		liberar_recur(view);
		view=null;
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_presente_enumerado', null);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_entrada', null);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_salida', null);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_walki', null);
		o_locutorio=null;		
	};
	this.init=function(p_olocu,p_height)
	{
		self=this;
		o_locutorio=p_olocu;
		view=Ti.UI.createScrollView(
			{
			height:p_height,
			scrollType: "horizontal",
			layout:"horizontal",backgroundColor:"#aaaaaa",
			contentWidth:"auto"
			}
		);
		aspecto_ventana(view);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_presente_enumerado', ev_locutorio_presente_enumerado);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_entrada', ev_locutorio_entrada);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_salida', ev_locutorio_salida);
		oglobal.ologic.myaddEventListener(oglobal.ologic,'locutorio_walki', ev_locutorio_walki);
		return view;		
	};
	this.cargar=function()
	{
		oglobal.ologic.locutorio_enumerar_presentes(o_locutorio.id);		
	};
	function ev_locutorio_presente_enumerado(p_param)
	{
		var t_op=p_param[0].opresente;
		var t_creador=t_op.creador;
		if(t_op.clave==0)
		{
			// fin de la enumaracion;
			return;
		}	
		var t_found=false;
		for(var t_n=0;t_n<view.children.length;t_n++)
		{
			if(view.children[t_n].clave==t_op.clave)
			{
				t_found=true;
				break;
			}
		}
		if(t_found) return;
		var conte_miembro_locutorio=require('/comun/locutorio_miembro.js');
		var t_o=new conte_miembro_locutorio();			
		var t_view=t_o.init(o_locutorio,t_op,t_creador);
		t_view.left=0;
		t_view.clave=t_op.clave;
		view.add(t_view);
	}
	function ev_locutorio_entrada(p_param)
	{
		var t_op=p_param[0].opresente;
		var t_creador=t_op.creador;

		var t_found=false;
		for(var t_n=0;t_n<view.children.length;t_n++)
		{
			if(view.children[t_n].clave==t_op.clave)
			{
				t_found=true;
				break;
			}
		}
		if(t_found) return;
		var conte_miembro_locutorio=require('/comun/locutorio_miembro.js');
		var t_o=new conte_miembro_locutorio();			
		var t_view=t_o.init(o_locutorio,t_op,t_creador);
		t_view.left=0;
		t_view.clave=t_op.clave;
		view.add(t_view);
	}
	function ev_locutorio_salida(p_param)
	{
		var t_op=p_param[0].opresente;
		self.quitar(t_op.clave);
	}
	this.quitar=function(p_clave)
	{
		var t_found=false;
		var t_id=0;
		for(var t_n=0;t_n<view.children.length;t_n++)
		{
			if(view.children[t_n].clave==p_clave)
			{
				t_found=true;
				t_id=t_n;
				break;
			}
		}
		if(!t_found) return;
		view.remove(view.children[t_id]);
	};
	function ev_locutorio_walki(p_param)
	{
		var t_clave=p_param[0].clave;
		var t_url=p_param[0].url;
		sonido_url(t_url);
	}
}				 
module.exports =conte_miembros_locutorio;