function win_store_detalle()
{
	var fun_comprado,item;
	var win;
	this.init=function(p_item,p_fun_comprado)
	{
		fun_comprado=p_fun_comprado;
		item=p_item;
		win = Titanium.UI.createWindow({  
			title:L("comprar_detalle","Detalle de Compra"),
			orientationModes:[Ti.UI.PORTRAIT,Ti.UI.UPSIDE_PORTRAIT],			
			 navBarHidden:false
			});
		aspecto_ventana(win);		
		var botonera=Ti.UI.createView(
			{
			bottom:0,height:factor(50),
			}
		);
		aspecto_botonera(botonera);
		if(os_ios())
		{
			var b_cerrar2=Titanium.UI.createButton({  
					title:L("volver",'Volver')
				});  
			win.leftNavButton=b_cerrar2;
			b_cerrar2.addEventListener('click', function(e){
				sonido("boton.mp3");
				cerrar();
			}); 
		}
		
		
		var t_url;
		
		t_url=url_server+"/info_compra_m.aspx?user="+oglobal.clave_usuario.toString()+"&juego="+oglobal.tipo_juego.toString();
		t_url+= "&clprod="+item.clave+"&idprod="+item.id_prod+"&precio="+item.precio+"&precio_formateado="+item.precio_formateado+"&titulo="+item.titulo+"&descrip="+item.descripcion;
		var webview = Titanium.UI.createWebView({url:t_url,
			top:0,bottom:factor(50),
			});
		win.add(webview);
		webview.addEventListener('beforeload', function(e){
//			if(e.navigationType==0 && e.url.search("#COMPRAR")>=0)
//			alert(e.url);
			if(e.url.search("#COMPRAR")>=0)
			{
	//			sonido("boton.mp3");
	//			comprar();
			}
			}); 		
		var b_comprar = crear_boton_imagen({  		
				top:0,bottom:0,
				width:"100%"
			},"/comprar.png");
		if(os_android())
		{
			if(InAppBilling)
			{
				if(InAppBilling.ok)
				{
					botonera.add(b_comprar);
				}	
			}
		}
		else
		{
			botonera.add(b_comprar);	
		}  
		
		win.add(botonera);
		b_comprar.addEventListener('click', function(e){
			sonido("boton.mp3");
			comprar();
		}); 
		win.addEventListener('android:back', function() {
			cerrar();
		});
		win.addEventListener('close', function() {
			cleanup();
		});
		
		
		win.add(loading);
	
		return win;	
	};
	function cerrar()
	{
		cerrar_ventana(win);
	}
	this._cerrar=function()
	{
		cerrar();
	};
	function cleanup()
	{
		if(win) win.remove(loading);
		win=null;
		item=null;
		fun_comprado=null;
		if(os_ios())
		{
			if(Storekit.fun_store_comprado_efectivo) Storekit.fun_store_comprado_efectivo=null;			
		}	
		else{
			if(InAppBilling.fun_store_comprado_efectivo) InAppBilling.fun_store_comprado_efectivo=null;			
		}	
	}
	function comprar()
	{		
		showLoading();
		if(!os_ios()) return comprar_android();
		requestProduct(item.id_prod,function precomprado(product){
			hideLoading();
			//alert(product.title+"*"+product.description);
			Storekit.fun_store_comprado_efectivo=fun_comprado;
			Storekit.clave_usuario=oglobal.clave_usuario;
			showLoading();
			Storekit.purchase({product:product,quantity:1});
		});			
	}
	function requestProduct(identifier, success)
	{
		Storekit.requestProducts([identifier], function (evt) {
			if(!win) return;			
			if (!evt.success) {
				alert(L("compra_no_conex_tienda","Error durante la conexión a la tienda"));
			}
			else if (evt.invalid) {
				alert(L("compra_invalido_producto","El producto indicado no es válido"));
			}
			else {
				success(evt.products[0]);
			}
		});
	}
	function comprar_android()
	{
		comprobar_inventario_android(item.id_prod);
	}
	function comprar_android_real(purchase)
	{		
		InAppBilling.fun_store_comprado_efectivo=fun_comprado;
					if(purchase)
					{
						if (purchase.purchaseState==0)
						{
							// le abonamos el tema;	
							var t_id_tran=purchase.orderId;
							var t_id_prod=purchase.productId;
							var t_id_compra=purchase.developerPayload;
							//alert(t_id_tran+"*"+t_id_prod+"*"+t_id_compra);
							
							suds.invoke("inappbilling_compra_recuperada", {p_id_compra:t_id_compra,p_orderid:t_id_tran,p_tpjuego:oglobal.tipo_juego.toString(),
								p_lng:get_lng_dispositivo(),p_serial:oglobal.serial}, function(xmlDoc) 
									{	
										var t_reg = xmlDoc.getElementsByTagName("tabla");
										var t_error=trim(t_reg.item(0).getElementsByTagName("error").item(0).textContent);
										var t_mensaje=trim(t_reg.item(0).getElementsByTagName("mensaje").item(0).textContent);
										var t_consumir=trim(t_reg.item(0).getElementsByTagName("consumir").item(0).textContent);
										if(t_consumir=="1")
										{
											InAppBilling.consume({
							                	purchases: [purchase]
							            	});																
										}
										hideLoading();
										if(t_error=="0")
										{
											
											if(InAppBilling.fun_store_comprado_efectivo) {
												InAppBilling.fun_store_comprado_efectivo();
												InAppBilling.fun_store_comprado_efectivo=null;
											}
											if(t_mensaje!="")
											{
												aviso(t_mensaje);
											}
										}
										else{
											if(t_mensaje!="")
											{
												aviso_error(t_mensaje);
											}	
																
										}
										hideLoading();	
									}, function error(){
										
										hideLoading();
										var t_mensa=L("error_inapp_sud3_comunicacion","Problema de comunicación con servidor UsuJuegos en recuperación");
										aviso_error(t_mensa);
									});						
			            	return;
						}
	            }


		
		
		suds.invoke("store_android_compra_en_tramite", {p_tpjuego:oglobal.tipo_juego.toString(),p_cl_user:oglobal.clave_usuario,p_id_prod:item.id_prod,p_unidades:1,
			p_precio:item.precio,p_precio_formateado:item.precio_formateado,p_lng:get_lng_dispositivo(),p_serial:oglobal.serial}, function(xmlDoc) 
		{
			var t_id_compra;
			var t_developerpayload;
			var t_reg = xmlDoc.getElementsByTagName("tabla");
			t_id_compra=trim(t_reg.item(0).getElementsByTagName("id_compra").item(0).textContent);
			if(t_id_compra==0) return false;
			InAppBilling.purchase({
	                productId: item.id_prod,
	                type: InAppBilling.ITEM_TYPE_INAPP,
	                developerPayload:t_id_compra
	            });
			
		},function nula(){
			hideLoading();
			var t_mensa=L("error_inapp_sud_comunicacion","Problema de comunicación con servidor UsuJuegos");
			aviso_error(t_mensa);
		});						

	}
	function comprobar_inventario_android(p_id_prod)
	{
		InAppBilling.fun_post_query=comprar_android_real;
		InAppBilling.id_prod_comprobando_inventario=p_id_prod;		
		InAppBilling.queryInventory({
			moreItems: [p_id_prod]
			}
			);
		
	}
}
module.exports=win_store_detalle;
